'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var reactDom = require('react-dom');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(source, true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(source).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function _classCallCheck$1(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties$1(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$1(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties$1(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties$1(Constructor, staticProps);
  return Constructor;
}

function _defineProperty$1(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty$1(target, key, source[key]);
    });
  }

  return target;
}

function _slicedToArray$1(arr, i) {
  return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _nonIterableRest$1();
}

function _arrayWithHoles$1(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit$1(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest$1() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var noop = function noop() {};

var _WINDOW = {};
var _DOCUMENT = {};
var _MUTATION_OBSERVER = null;
var _PERFORMANCE = {
  mark: noop,
  measure: noop
};

try {
  if (typeof window !== 'undefined') _WINDOW = window;
  if (typeof document !== 'undefined') _DOCUMENT = document;
  if (typeof MutationObserver !== 'undefined') _MUTATION_OBSERVER = MutationObserver;
  if (typeof performance !== 'undefined') _PERFORMANCE = performance;
} catch (e) {}

var _ref = _WINDOW.navigator || {},
    _ref$userAgent = _ref.userAgent,
    userAgent = _ref$userAgent === void 0 ? '' : _ref$userAgent;

var WINDOW = _WINDOW;
var DOCUMENT = _DOCUMENT;
var PERFORMANCE = _PERFORMANCE;
var IS_BROWSER = !!WINDOW.document;
var IS_DOM = !!DOCUMENT.documentElement && !!DOCUMENT.head && typeof DOCUMENT.addEventListener === 'function' && typeof DOCUMENT.createElement === 'function';
var IS_IE = ~userAgent.indexOf('MSIE') || ~userAgent.indexOf('Trident/');

var NAMESPACE_IDENTIFIER = '___FONT_AWESOME___';
var DEFAULT_FAMILY_PREFIX = 'fa';
var DEFAULT_REPLACEMENT_CLASS = 'svg-inline--fa';
var DATA_FA_I2SVG = 'data-fa-i2svg';
var PRODUCTION = function () {
  try {
    return process.env.NODE_ENV === 'production';
  } catch (e) {
    return false;
  }
}();

var initial = WINDOW.FontAwesomeConfig || {};

function getAttrConfig(attr) {
  var element = DOCUMENT.querySelector('script[' + attr + ']');

  if (element) {
    return element.getAttribute(attr);
  }
}

function coerce(val) {
  // Getting an empty string will occur if the attribute is set on the HTML tag but without a value
  // We'll assume that this is an indication that it should be toggled to true
  // For example <script data-search-pseudo-elements src="..."></script>
  if (val === '') return true;
  if (val === 'false') return false;
  if (val === 'true') return true;
  return val;
}

if (DOCUMENT && typeof DOCUMENT.querySelector === 'function') {
  var attrs = [['data-family-prefix', 'familyPrefix'], ['data-replacement-class', 'replacementClass'], ['data-auto-replace-svg', 'autoReplaceSvg'], ['data-auto-add-css', 'autoAddCss'], ['data-auto-a11y', 'autoA11y'], ['data-search-pseudo-elements', 'searchPseudoElements'], ['data-observe-mutations', 'observeMutations'], ['data-mutate-approach', 'mutateApproach'], ['data-keep-original-source', 'keepOriginalSource'], ['data-measure-performance', 'measurePerformance'], ['data-show-missing-icons', 'showMissingIcons']];
  attrs.forEach(function (_ref) {
    var _ref2 = _slicedToArray$1(_ref, 2),
        attr = _ref2[0],
        key = _ref2[1];

    var val = coerce(getAttrConfig(attr));

    if (val !== undefined && val !== null) {
      initial[key] = val;
    }
  });
}

var _default = {
  familyPrefix: DEFAULT_FAMILY_PREFIX,
  replacementClass: DEFAULT_REPLACEMENT_CLASS,
  autoReplaceSvg: true,
  autoAddCss: true,
  autoA11y: true,
  searchPseudoElements: false,
  observeMutations: true,
  mutateApproach: 'async',
  keepOriginalSource: true,
  measurePerformance: false,
  showMissingIcons: true
};

var _config = _objectSpread({}, _default, initial);

if (!_config.autoReplaceSvg) _config.observeMutations = false;

var config = _objectSpread({}, _config);

WINDOW.FontAwesomeConfig = config;

var w = WINDOW || {};
if (!w[NAMESPACE_IDENTIFIER]) w[NAMESPACE_IDENTIFIER] = {};
if (!w[NAMESPACE_IDENTIFIER].styles) w[NAMESPACE_IDENTIFIER].styles = {};
if (!w[NAMESPACE_IDENTIFIER].hooks) w[NAMESPACE_IDENTIFIER].hooks = {};
if (!w[NAMESPACE_IDENTIFIER].shims) w[NAMESPACE_IDENTIFIER].shims = [];
var namespace = w[NAMESPACE_IDENTIFIER];

var functions = [];

var listener = function listener() {
  DOCUMENT.removeEventListener('DOMContentLoaded', listener);
  loaded = 1;
  functions.map(function (fn) {
    return fn();
  });
};

var loaded = false;

if (IS_DOM) {
  loaded = (DOCUMENT.documentElement.doScroll ? /^loaded|^c/ : /^loaded|^i|^c/).test(DOCUMENT.readyState);
  if (!loaded) DOCUMENT.addEventListener('DOMContentLoaded', listener);
}

var isNode = typeof global !== 'undefined' && typeof global.process !== 'undefined' && typeof global.process.emit === 'function';
var meaninglessTransform = {
  size: 16,
  x: 0,
  y: 0,
  rotate: 0,
  flipX: false,
  flipY: false
};
function insertCss(css) {
  if (!css || !IS_DOM) {
    return;
  }

  var style = DOCUMENT.createElement('style');
  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  var headChildren = DOCUMENT.head.childNodes;
  var beforeChild = null;

  for (var i = headChildren.length - 1; i > -1; i--) {
    var child = headChildren[i];
    var tagName = (child.tagName || '').toUpperCase();

    if (['STYLE', 'LINK'].indexOf(tagName) > -1) {
      beforeChild = child;
    }
  }

  DOCUMENT.head.insertBefore(style, beforeChild);
  return css;
}
var idPool = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
function nextUniqueId() {
  var size = 12;
  var id = '';

  while (size-- > 0) {
    id += idPool[Math.random() * 62 | 0];
  }

  return id;
}
function htmlEscape(str) {
  return "".concat(str).replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#39;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}
function joinAttributes(attributes) {
  return Object.keys(attributes || {}).reduce(function (acc, attributeName) {
    return acc + "".concat(attributeName, "=\"").concat(htmlEscape(attributes[attributeName]), "\" ");
  }, '').trim();
}
function joinStyles(styles) {
  return Object.keys(styles || {}).reduce(function (acc, styleName) {
    return acc + "".concat(styleName, ": ").concat(styles[styleName], ";");
  }, '');
}
function transformIsMeaningful(transform) {
  return transform.size !== meaninglessTransform.size || transform.x !== meaninglessTransform.x || transform.y !== meaninglessTransform.y || transform.rotate !== meaninglessTransform.rotate || transform.flipX || transform.flipY;
}
function transformForSvg(_ref) {
  var transform = _ref.transform,
      containerWidth = _ref.containerWidth,
      iconWidth = _ref.iconWidth;
  var outer = {
    transform: "translate(".concat(containerWidth / 2, " 256)")
  };
  var innerTranslate = "translate(".concat(transform.x * 32, ", ").concat(transform.y * 32, ") ");
  var innerScale = "scale(".concat(transform.size / 16 * (transform.flipX ? -1 : 1), ", ").concat(transform.size / 16 * (transform.flipY ? -1 : 1), ") ");
  var innerRotate = "rotate(".concat(transform.rotate, " 0 0)");
  var inner = {
    transform: "".concat(innerTranslate, " ").concat(innerScale, " ").concat(innerRotate)
  };
  var path = {
    transform: "translate(".concat(iconWidth / 2 * -1, " -256)")
  };
  return {
    outer: outer,
    inner: inner,
    path: path
  };
}

var ALL_SPACE = {
  x: 0,
  y: 0,
  width: '100%',
  height: '100%'
};
function makeIconMasking (_ref) {
  var children = _ref.children,
      attributes = _ref.attributes,
      main = _ref.main,
      mask = _ref.mask,
      transform = _ref.transform;
  var mainWidth = main.width,
      mainPath = main.icon;
  var maskWidth = mask.width,
      maskPath = mask.icon;
  var trans = transformForSvg({
    transform: transform,
    containerWidth: maskWidth,
    iconWidth: mainWidth
  });
  var maskRect = {
    tag: 'rect',
    attributes: _objectSpread({}, ALL_SPACE, {
      fill: 'white'
    })
  };
  var maskInnerGroup = {
    tag: 'g',
    attributes: _objectSpread({}, trans.inner),
    children: [{
      tag: 'path',
      attributes: _objectSpread({}, mainPath.attributes, trans.path, {
        fill: 'black'
      })
    }]
  };
  var maskOuterGroup = {
    tag: 'g',
    attributes: _objectSpread({}, trans.outer),
    children: [maskInnerGroup]
  };
  var maskId = "mask-".concat(nextUniqueId());
  var clipId = "clip-".concat(nextUniqueId());
  var maskTag = {
    tag: 'mask',
    attributes: _objectSpread({}, ALL_SPACE, {
      id: maskId,
      maskUnits: 'userSpaceOnUse',
      maskContentUnits: 'userSpaceOnUse'
    }),
    children: [maskRect, maskOuterGroup]
  };
  var defs = {
    tag: 'defs',
    children: [{
      tag: 'clipPath',
      attributes: {
        id: clipId
      },
      children: [maskPath]
    }, maskTag]
  };
  children.push(defs, {
    tag: 'rect',
    attributes: _objectSpread({
      fill: 'currentColor',
      'clip-path': "url(#".concat(clipId, ")"),
      mask: "url(#".concat(maskId, ")")
    }, ALL_SPACE)
  });
  return {
    children: children,
    attributes: attributes
  };
}

function makeIconStandard (_ref) {
  var children = _ref.children,
      attributes = _ref.attributes,
      main = _ref.main,
      transform = _ref.transform,
      styles = _ref.styles;
  var styleString = joinStyles(styles);

  if (styleString.length > 0) {
    attributes['style'] = styleString;
  }

  if (transformIsMeaningful(transform)) {
    var trans = transformForSvg({
      transform: transform,
      containerWidth: main.width,
      iconWidth: main.width
    });
    children.push({
      tag: 'g',
      attributes: _objectSpread({}, trans.outer),
      children: [{
        tag: 'g',
        attributes: _objectSpread({}, trans.inner),
        children: [{
          tag: main.icon.tag,
          children: main.icon.children,
          attributes: _objectSpread({}, main.icon.attributes, trans.path)
        }]
      }]
    });
  } else {
    children.push(main.icon);
  }

  return {
    children: children,
    attributes: attributes
  };
}

function asIcon (_ref) {
  var children = _ref.children,
      main = _ref.main,
      mask = _ref.mask,
      attributes = _ref.attributes,
      styles = _ref.styles,
      transform = _ref.transform;

  if (transformIsMeaningful(transform) && main.found && !mask.found) {
    var width = main.width,
        height = main.height;
    var offset = {
      x: width / height / 2,
      y: 0.5
    };
    attributes['style'] = joinStyles(_objectSpread({}, styles, {
      'transform-origin': "".concat(offset.x + transform.x / 16, "em ").concat(offset.y + transform.y / 16, "em")
    }));
  }

  return [{
    tag: 'svg',
    attributes: attributes,
    children: children
  }];
}

function asSymbol (_ref) {
  var prefix = _ref.prefix,
      iconName = _ref.iconName,
      children = _ref.children,
      attributes = _ref.attributes,
      symbol = _ref.symbol;
  var id = symbol === true ? "".concat(prefix, "-").concat(config.familyPrefix, "-").concat(iconName) : symbol;
  return [{
    tag: 'svg',
    attributes: {
      style: 'display: none;'
    },
    children: [{
      tag: 'symbol',
      attributes: _objectSpread({}, attributes, {
        id: id
      }),
      children: children
    }]
  }];
}

function makeInlineSvgAbstract(params) {
  var _params$icons = params.icons,
      main = _params$icons.main,
      mask = _params$icons.mask,
      prefix = params.prefix,
      iconName = params.iconName,
      transform = params.transform,
      symbol = params.symbol,
      title = params.title,
      extra = params.extra,
      _params$watchable = params.watchable,
      watchable = _params$watchable === void 0 ? false : _params$watchable;

  var _ref = mask.found ? mask : main,
      width = _ref.width,
      height = _ref.height;

  var widthClass = "fa-w-".concat(Math.ceil(width / height * 16));
  var attrClass = [config.replacementClass, iconName ? "".concat(config.familyPrefix, "-").concat(iconName) : '', widthClass].filter(function (c) {
    return extra.classes.indexOf(c) === -1;
  }).concat(extra.classes).join(' ');
  var content = {
    children: [],
    attributes: _objectSpread({}, extra.attributes, {
      'data-prefix': prefix,
      'data-icon': iconName,
      'class': attrClass,
      'role': extra.attributes.role || 'img',
      'xmlns': 'http://www.w3.org/2000/svg',
      'viewBox': "0 0 ".concat(width, " ").concat(height)
    })
  };

  if (watchable) {
    content.attributes[DATA_FA_I2SVG] = '';
  }

  if (title) content.children.push({
    tag: 'title',
    attributes: {
      id: content.attributes['aria-labelledby'] || "title-".concat(nextUniqueId())
    },
    children: [title]
  });

  var args = _objectSpread({}, content, {
    prefix: prefix,
    iconName: iconName,
    main: main,
    mask: mask,
    transform: transform,
    symbol: symbol,
    styles: extra.styles
  });

  var _ref2 = mask.found && main.found ? makeIconMasking(args) : makeIconStandard(args),
      children = _ref2.children,
      attributes = _ref2.attributes;

  args.children = children;
  args.attributes = attributes;

  if (symbol) {
    return asSymbol(args);
  } else {
    return asIcon(args);
  }
}

var noop$1 = function noop() {};

var p = config.measurePerformance && PERFORMANCE && PERFORMANCE.mark && PERFORMANCE.measure ? PERFORMANCE : {
  mark: noop$1,
  measure: noop$1
};

/**
 * Internal helper to bind a function known to have 4 arguments
 * to a given context.
 */

var bindInternal4 = function bindInternal4(func, thisContext) {
  return function (a, b, c, d) {
    return func.call(thisContext, a, b, c, d);
  };
};

/**
 * # Reduce
 *
 * A fast object `.reduce()` implementation.
 *
 * @param  {Object}   subject      The object to reduce over.
 * @param  {Function} fn           The reducer function.
 * @param  {mixed}    initialValue The initial value for the reducer, defaults to subject[0].
 * @param  {Object}   thisContext  The context for the reducer.
 * @return {mixed}                 The final result.
 */


var reduce = function fastReduceObject(subject, fn, initialValue, thisContext) {
  var keys = Object.keys(subject),
      length = keys.length,
      iterator = thisContext !== undefined ? bindInternal4(fn, thisContext) : fn,
      i,
      key,
      result;

  if (initialValue === undefined) {
    i = 1;
    result = subject[keys[0]];
  } else {
    i = 0;
    result = initialValue;
  }

  for (; i < length; i++) {
    key = keys[i];
    result = iterator(result, subject[key], key, subject);
  }

  return result;
};

function defineIcons(prefix, icons) {
  var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var _params$skipHooks = params.skipHooks,
      skipHooks = _params$skipHooks === void 0 ? false : _params$skipHooks;
  var normalized = Object.keys(icons).reduce(function (acc, iconName) {
    var icon = icons[iconName];
    var expanded = !!icon.icon;

    if (expanded) {
      acc[icon.iconName] = icon.icon;
    } else {
      acc[iconName] = icon;
    }

    return acc;
  }, {});

  if (typeof namespace.hooks.addPack === 'function' && !skipHooks) {
    namespace.hooks.addPack(prefix, normalized);
  } else {
    namespace.styles[prefix] = _objectSpread({}, namespace.styles[prefix] || {}, normalized);
  }
  /**
   * Font Awesome 4 used the prefix of `fa` for all icons. With the introduction
   * of new styles we needed to differentiate between them. Prefix `fa` is now an alias
   * for `fas` so we'll easy the upgrade process for our users by automatically defining
   * this as well.
   */


  if (prefix === 'fas') {
    defineIcons('fa', icons);
  }
}

var styles = namespace.styles,
    shims = namespace.shims;
var _byUnicode = {};
var _byLigature = {};
var _byOldName = {};
var build = function build() {
  var lookup = function lookup(reducer) {
    return reduce(styles, function (o, style, prefix) {
      o[prefix] = reduce(style, reducer, {});
      return o;
    }, {});
  };

  _byUnicode = lookup(function (acc, icon, iconName) {
    if (icon[3]) {
      acc[icon[3]] = iconName;
    }

    return acc;
  });
  _byLigature = lookup(function (acc, icon, iconName) {
    var ligatures = icon[2];
    acc[iconName] = iconName;
    ligatures.forEach(function (ligature) {
      acc[ligature] = iconName;
    });
    return acc;
  });
  var hasRegular = 'far' in styles;
  _byOldName = reduce(shims, function (acc, shim) {
    var oldName = shim[0];
    var prefix = shim[1];
    var iconName = shim[2];

    if (prefix === 'far' && !hasRegular) {
      prefix = 'fas';
    }

    acc[oldName] = {
      prefix: prefix,
      iconName: iconName
    };
    return acc;
  }, {});
};
build();

var styles$1 = namespace.styles;
function iconFromMapping(mapping, prefix, iconName) {
  if (mapping && mapping[prefix] && mapping[prefix][iconName]) {
    return {
      prefix: prefix,
      iconName: iconName,
      icon: mapping[prefix][iconName]
    };
  }
}

function toHtml(abstractNodes) {
  var tag = abstractNodes.tag,
      _abstractNodes$attrib = abstractNodes.attributes,
      attributes = _abstractNodes$attrib === void 0 ? {} : _abstractNodes$attrib,
      _abstractNodes$childr = abstractNodes.children,
      children = _abstractNodes$childr === void 0 ? [] : _abstractNodes$childr;

  if (typeof abstractNodes === 'string') {
    return htmlEscape(abstractNodes);
  } else {
    return "<".concat(tag, " ").concat(joinAttributes(attributes), ">").concat(children.map(toHtml).join(''), "</").concat(tag, ">");
  }
}

var parseTransformString = function parseTransformString(transformString) {
  var transform = {
    size: 16,
    x: 0,
    y: 0,
    flipX: false,
    flipY: false,
    rotate: 0
  };

  if (!transformString) {
    return transform;
  } else {
    return transformString.toLowerCase().split(' ').reduce(function (acc, n) {
      var parts = n.toLowerCase().split('-');
      var first = parts[0];
      var rest = parts.slice(1).join('-');

      if (first && rest === 'h') {
        acc.flipX = true;
        return acc;
      }

      if (first && rest === 'v') {
        acc.flipY = true;
        return acc;
      }

      rest = parseFloat(rest);

      if (isNaN(rest)) {
        return acc;
      }

      switch (first) {
        case 'grow':
          acc.size = acc.size + rest;
          break;

        case 'shrink':
          acc.size = acc.size - rest;
          break;

        case 'left':
          acc.x = acc.x - rest;
          break;

        case 'right':
          acc.x = acc.x + rest;
          break;

        case 'up':
          acc.y = acc.y - rest;
          break;

        case 'down':
          acc.y = acc.y + rest;
          break;

        case 'rotate':
          acc.rotate = acc.rotate + rest;
          break;
      }

      return acc;
    }, transform);
  }
};

function MissingIcon(error) {
  this.name = 'MissingIcon';
  this.message = error || 'Icon unavailable';
  this.stack = new Error().stack;
}
MissingIcon.prototype = Object.create(Error.prototype);
MissingIcon.prototype.constructor = MissingIcon;

var FILL = {
  fill: 'currentColor'
};
var ANIMATION_BASE = {
  attributeType: 'XML',
  repeatCount: 'indefinite',
  dur: '2s'
};
var RING = {
  tag: 'path',
  attributes: _objectSpread({}, FILL, {
    d: 'M156.5,447.7l-12.6,29.5c-18.7-9.5-35.9-21.2-51.5-34.9l22.7-22.7C127.6,430.5,141.5,440,156.5,447.7z M40.6,272H8.5 c1.4,21.2,5.4,41.7,11.7,61.1L50,321.2C45.1,305.5,41.8,289,40.6,272z M40.6,240c1.4-18.8,5.2-37,11.1-54.1l-29.5-12.6 C14.7,194.3,10,216.7,8.5,240H40.6z M64.3,156.5c7.8-14.9,17.2-28.8,28.1-41.5L69.7,92.3c-13.7,15.6-25.5,32.8-34.9,51.5 L64.3,156.5z M397,419.6c-13.9,12-29.4,22.3-46.1,30.4l11.9,29.8c20.7-9.9,39.8-22.6,56.9-37.6L397,419.6z M115,92.4 c13.9-12,29.4-22.3,46.1-30.4l-11.9-29.8c-20.7,9.9-39.8,22.6-56.8,37.6L115,92.4z M447.7,355.5c-7.8,14.9-17.2,28.8-28.1,41.5 l22.7,22.7c13.7-15.6,25.5-32.9,34.9-51.5L447.7,355.5z M471.4,272c-1.4,18.8-5.2,37-11.1,54.1l29.5,12.6 c7.5-21.1,12.2-43.5,13.6-66.8H471.4z M321.2,462c-15.7,5-32.2,8.2-49.2,9.4v32.1c21.2-1.4,41.7-5.4,61.1-11.7L321.2,462z M240,471.4c-18.8-1.4-37-5.2-54.1-11.1l-12.6,29.5c21.1,7.5,43.5,12.2,66.8,13.6V471.4z M462,190.8c5,15.7,8.2,32.2,9.4,49.2h32.1 c-1.4-21.2-5.4-41.7-11.7-61.1L462,190.8z M92.4,397c-12-13.9-22.3-29.4-30.4-46.1l-29.8,11.9c9.9,20.7,22.6,39.8,37.6,56.9 L92.4,397z M272,40.6c18.8,1.4,36.9,5.2,54.1,11.1l12.6-29.5C317.7,14.7,295.3,10,272,8.5V40.6z M190.8,50 c15.7-5,32.2-8.2,49.2-9.4V8.5c-21.2,1.4-41.7,5.4-61.1,11.7L190.8,50z M442.3,92.3L419.6,115c12,13.9,22.3,29.4,30.5,46.1 l29.8-11.9C470,128.5,457.3,109.4,442.3,92.3z M397,92.4l22.7-22.7c-15.6-13.7-32.8-25.5-51.5-34.9l-12.6,29.5 C370.4,72.1,384.4,81.5,397,92.4z'
  })
};

var OPACITY_ANIMATE = _objectSpread({}, ANIMATION_BASE, {
  attributeName: 'opacity'
});

var DOT = {
  tag: 'circle',
  attributes: _objectSpread({}, FILL, {
    cx: '256',
    cy: '364',
    r: '28'
  }),
  children: [{
    tag: 'animate',
    attributes: _objectSpread({}, ANIMATION_BASE, {
      attributeName: 'r',
      values: '28;14;28;28;14;28;'
    })
  }, {
    tag: 'animate',
    attributes: _objectSpread({}, OPACITY_ANIMATE, {
      values: '1;0;1;1;0;1;'
    })
  }]
};
var QUESTION = {
  tag: 'path',
  attributes: _objectSpread({}, FILL, {
    opacity: '1',
    d: 'M263.7,312h-16c-6.6,0-12-5.4-12-12c0-71,77.4-63.9,77.4-107.8c0-20-17.8-40.2-57.4-40.2c-29.1,0-44.3,9.6-59.2,28.7 c-3.9,5-11.1,6-16.2,2.4l-13.1-9.2c-5.6-3.9-6.9-11.8-2.6-17.2c21.2-27.2,46.4-44.7,91.2-44.7c52.3,0,97.4,29.8,97.4,80.2 c0,67.6-77.4,63.5-77.4,107.8C275.7,306.6,270.3,312,263.7,312z'
  }),
  children: [{
    tag: 'animate',
    attributes: _objectSpread({}, OPACITY_ANIMATE, {
      values: '1;0;0;0;0;1;'
    })
  }]
};
var EXCLAMATION = {
  tag: 'path',
  attributes: _objectSpread({}, FILL, {
    opacity: '0',
    d: 'M232.5,134.5l7,168c0.3,6.4,5.6,11.5,12,11.5h9c6.4,0,11.7-5.1,12-11.5l7-168c0.3-6.8-5.2-12.5-12-12.5h-23 C237.7,122,232.2,127.7,232.5,134.5z'
  }),
  children: [{
    tag: 'animate',
    attributes: _objectSpread({}, OPACITY_ANIMATE, {
      values: '0;0;1;1;0;0;'
    })
  }]
};

var styles$2 = namespace.styles;

var styles$3 = namespace.styles;

var baseStyles = "svg:not(:root).svg-inline--fa {\n  overflow: visible;\n}\n\n.svg-inline--fa {\n  display: inline-block;\n  font-size: inherit;\n  height: 1em;\n  overflow: visible;\n  vertical-align: -0.125em;\n}\n.svg-inline--fa.fa-lg {\n  vertical-align: -0.225em;\n}\n.svg-inline--fa.fa-w-1 {\n  width: 0.0625em;\n}\n.svg-inline--fa.fa-w-2 {\n  width: 0.125em;\n}\n.svg-inline--fa.fa-w-3 {\n  width: 0.1875em;\n}\n.svg-inline--fa.fa-w-4 {\n  width: 0.25em;\n}\n.svg-inline--fa.fa-w-5 {\n  width: 0.3125em;\n}\n.svg-inline--fa.fa-w-6 {\n  width: 0.375em;\n}\n.svg-inline--fa.fa-w-7 {\n  width: 0.4375em;\n}\n.svg-inline--fa.fa-w-8 {\n  width: 0.5em;\n}\n.svg-inline--fa.fa-w-9 {\n  width: 0.5625em;\n}\n.svg-inline--fa.fa-w-10 {\n  width: 0.625em;\n}\n.svg-inline--fa.fa-w-11 {\n  width: 0.6875em;\n}\n.svg-inline--fa.fa-w-12 {\n  width: 0.75em;\n}\n.svg-inline--fa.fa-w-13 {\n  width: 0.8125em;\n}\n.svg-inline--fa.fa-w-14 {\n  width: 0.875em;\n}\n.svg-inline--fa.fa-w-15 {\n  width: 0.9375em;\n}\n.svg-inline--fa.fa-w-16 {\n  width: 1em;\n}\n.svg-inline--fa.fa-w-17 {\n  width: 1.0625em;\n}\n.svg-inline--fa.fa-w-18 {\n  width: 1.125em;\n}\n.svg-inline--fa.fa-w-19 {\n  width: 1.1875em;\n}\n.svg-inline--fa.fa-w-20 {\n  width: 1.25em;\n}\n.svg-inline--fa.fa-pull-left {\n  margin-right: 0.3em;\n  width: auto;\n}\n.svg-inline--fa.fa-pull-right {\n  margin-left: 0.3em;\n  width: auto;\n}\n.svg-inline--fa.fa-border {\n  height: 1.5em;\n}\n.svg-inline--fa.fa-li {\n  width: 2em;\n}\n.svg-inline--fa.fa-fw {\n  width: 1.25em;\n}\n\n.fa-layers svg.svg-inline--fa {\n  bottom: 0;\n  left: 0;\n  margin: auto;\n  position: absolute;\n  right: 0;\n  top: 0;\n}\n\n.fa-layers {\n  display: inline-block;\n  height: 1em;\n  position: relative;\n  text-align: center;\n  vertical-align: -0.125em;\n  width: 1em;\n}\n.fa-layers svg.svg-inline--fa {\n  -webkit-transform-origin: center center;\n          transform-origin: center center;\n}\n\n.fa-layers-counter, .fa-layers-text {\n  display: inline-block;\n  position: absolute;\n  text-align: center;\n}\n\n.fa-layers-text {\n  left: 50%;\n  top: 50%;\n  -webkit-transform: translate(-50%, -50%);\n          transform: translate(-50%, -50%);\n  -webkit-transform-origin: center center;\n          transform-origin: center center;\n}\n\n.fa-layers-counter {\n  background-color: #ff253a;\n  border-radius: 1em;\n  -webkit-box-sizing: border-box;\n          box-sizing: border-box;\n  color: #fff;\n  height: 1.5em;\n  line-height: 1;\n  max-width: 5em;\n  min-width: 1.5em;\n  overflow: hidden;\n  padding: 0.25em;\n  right: 0;\n  text-overflow: ellipsis;\n  top: 0;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: top right;\n          transform-origin: top right;\n}\n\n.fa-layers-bottom-right {\n  bottom: 0;\n  right: 0;\n  top: auto;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: bottom right;\n          transform-origin: bottom right;\n}\n\n.fa-layers-bottom-left {\n  bottom: 0;\n  left: 0;\n  right: auto;\n  top: auto;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: bottom left;\n          transform-origin: bottom left;\n}\n\n.fa-layers-top-right {\n  right: 0;\n  top: 0;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: top right;\n          transform-origin: top right;\n}\n\n.fa-layers-top-left {\n  left: 0;\n  right: auto;\n  top: 0;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: top left;\n          transform-origin: top left;\n}\n\n.fa-lg {\n  font-size: 1.3333333333em;\n  line-height: 0.75em;\n  vertical-align: -0.0667em;\n}\n\n.fa-xs {\n  font-size: 0.75em;\n}\n\n.fa-sm {\n  font-size: 0.875em;\n}\n\n.fa-1x {\n  font-size: 1em;\n}\n\n.fa-2x {\n  font-size: 2em;\n}\n\n.fa-3x {\n  font-size: 3em;\n}\n\n.fa-4x {\n  font-size: 4em;\n}\n\n.fa-5x {\n  font-size: 5em;\n}\n\n.fa-6x {\n  font-size: 6em;\n}\n\n.fa-7x {\n  font-size: 7em;\n}\n\n.fa-8x {\n  font-size: 8em;\n}\n\n.fa-9x {\n  font-size: 9em;\n}\n\n.fa-10x {\n  font-size: 10em;\n}\n\n.fa-fw {\n  text-align: center;\n  width: 1.25em;\n}\n\n.fa-ul {\n  list-style-type: none;\n  margin-left: 2.5em;\n  padding-left: 0;\n}\n.fa-ul > li {\n  position: relative;\n}\n\n.fa-li {\n  left: -2em;\n  position: absolute;\n  text-align: center;\n  width: 2em;\n  line-height: inherit;\n}\n\n.fa-border {\n  border: solid 0.08em #eee;\n  border-radius: 0.1em;\n  padding: 0.2em 0.25em 0.15em;\n}\n\n.fa-pull-left {\n  float: left;\n}\n\n.fa-pull-right {\n  float: right;\n}\n\n.fa.fa-pull-left,\n.fas.fa-pull-left,\n.far.fa-pull-left,\n.fal.fa-pull-left,\n.fab.fa-pull-left {\n  margin-right: 0.3em;\n}\n.fa.fa-pull-right,\n.fas.fa-pull-right,\n.far.fa-pull-right,\n.fal.fa-pull-right,\n.fab.fa-pull-right {\n  margin-left: 0.3em;\n}\n\n.fa-spin {\n  -webkit-animation: fa-spin 2s infinite linear;\n          animation: fa-spin 2s infinite linear;\n}\n\n.fa-pulse {\n  -webkit-animation: fa-spin 1s infinite steps(8);\n          animation: fa-spin 1s infinite steps(8);\n}\n\n@-webkit-keyframes fa-spin {\n  0% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg);\n  }\n  100% {\n    -webkit-transform: rotate(360deg);\n            transform: rotate(360deg);\n  }\n}\n\n@keyframes fa-spin {\n  0% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg);\n  }\n  100% {\n    -webkit-transform: rotate(360deg);\n            transform: rotate(360deg);\n  }\n}\n.fa-rotate-90 {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=1)\";\n  -webkit-transform: rotate(90deg);\n          transform: rotate(90deg);\n}\n\n.fa-rotate-180 {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2)\";\n  -webkit-transform: rotate(180deg);\n          transform: rotate(180deg);\n}\n\n.fa-rotate-270 {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n  -webkit-transform: rotate(270deg);\n          transform: rotate(270deg);\n}\n\n.fa-flip-horizontal {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=0, mirror=1)\";\n  -webkit-transform: scale(-1, 1);\n          transform: scale(-1, 1);\n}\n\n.fa-flip-vertical {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2, mirror=1)\";\n  -webkit-transform: scale(1, -1);\n          transform: scale(1, -1);\n}\n\n.fa-flip-both, .fa-flip-horizontal.fa-flip-vertical {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2, mirror=1)\";\n  -webkit-transform: scale(-1, -1);\n          transform: scale(-1, -1);\n}\n\n:root .fa-rotate-90,\n:root .fa-rotate-180,\n:root .fa-rotate-270,\n:root .fa-flip-horizontal,\n:root .fa-flip-vertical,\n:root .fa-flip-both {\n  -webkit-filter: none;\n          filter: none;\n}\n\n.fa-stack {\n  display: inline-block;\n  height: 2em;\n  position: relative;\n  width: 2.5em;\n}\n\n.fa-stack-1x,\n.fa-stack-2x {\n  bottom: 0;\n  left: 0;\n  margin: auto;\n  position: absolute;\n  right: 0;\n  top: 0;\n}\n\n.svg-inline--fa.fa-stack-1x {\n  height: 1em;\n  width: 1.25em;\n}\n.svg-inline--fa.fa-stack-2x {\n  height: 2em;\n  width: 2.5em;\n}\n\n.fa-inverse {\n  color: #fff;\n}\n\n.sr-only {\n  border: 0;\n  clip: rect(0, 0, 0, 0);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  width: 1px;\n}\n\n.sr-only-focusable:active, .sr-only-focusable:focus {\n  clip: auto;\n  height: auto;\n  margin: 0;\n  overflow: visible;\n  position: static;\n  width: auto;\n}";

function css () {
  var dfp = DEFAULT_FAMILY_PREFIX;
  var drc = DEFAULT_REPLACEMENT_CLASS;
  var fp = config.familyPrefix;
  var rc = config.replacementClass;
  var s = baseStyles;

  if (fp !== dfp || rc !== drc) {
    var dPatt = new RegExp("\\.".concat(dfp, "\\-"), 'g');
    var rPatt = new RegExp("\\.".concat(drc), 'g');
    s = s.replace(dPatt, ".".concat(fp, "-")).replace(rPatt, ".".concat(rc));
  }

  return s;
}

var Library =
/*#__PURE__*/
function () {
  function Library() {
    _classCallCheck$1(this, Library);

    this.definitions = {};
  }

  _createClass$1(Library, [{
    key: "add",
    value: function add() {
      var _this = this;

      for (var _len = arguments.length, definitions = new Array(_len), _key = 0; _key < _len; _key++) {
        definitions[_key] = arguments[_key];
      }

      var additions = definitions.reduce(this._pullDefinitions, {});
      Object.keys(additions).forEach(function (key) {
        _this.definitions[key] = _objectSpread({}, _this.definitions[key] || {}, additions[key]);
        defineIcons(key, additions[key]);
        build();
      });
    }
  }, {
    key: "reset",
    value: function reset() {
      this.definitions = {};
    }
  }, {
    key: "_pullDefinitions",
    value: function _pullDefinitions(additions, definition) {
      var normalized = definition.prefix && definition.iconName && definition.icon ? {
        0: definition
      } : definition;
      Object.keys(normalized).map(function (key) {
        var _normalized$key = normalized[key],
            prefix = _normalized$key.prefix,
            iconName = _normalized$key.iconName,
            icon = _normalized$key.icon;
        if (!additions[prefix]) additions[prefix] = {};
        additions[prefix][iconName] = icon;
      });
      return additions;
    }
  }]);

  return Library;
}();

function prepIcon(icon) {
  var width = icon[0];
  var height = icon[1];
  var vectorData = icon.slice(4);
  return {
    found: true,
    width: width,
    height: height,
    icon: {
      tag: 'path',
      attributes: {
        fill: 'currentColor',
        d: vectorData[0]
      }
    }
  };
}

function ensureCss() {
  if (config.autoAddCss && !_cssInserted) {
    insertCss(css());

    _cssInserted = true;
  }
}

function apiObject(val, abstractCreator) {
  Object.defineProperty(val, 'abstract', {
    get: abstractCreator
  });
  Object.defineProperty(val, 'html', {
    get: function get() {
      return val.abstract.map(function (a) {
        return toHtml(a);
      });
    }
  });
  Object.defineProperty(val, 'node', {
    get: function get() {
      if (!IS_DOM) return;
      var container = DOCUMENT.createElement('div');
      container.innerHTML = val.html;
      return container.children;
    }
  });
  return val;
}

function findIconDefinition(iconLookup) {
  var _iconLookup$prefix = iconLookup.prefix,
      prefix = _iconLookup$prefix === void 0 ? 'fa' : _iconLookup$prefix,
      iconName = iconLookup.iconName;
  if (!iconName) return;
  return iconFromMapping(library.definitions, prefix, iconName) || iconFromMapping(namespace.styles, prefix, iconName);
}

function resolveIcons(next) {
  return function (maybeIconDefinition) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var iconDefinition = (maybeIconDefinition || {}).icon ? maybeIconDefinition : findIconDefinition(maybeIconDefinition || {});
    var mask = params.mask;

    if (mask) {
      mask = (mask || {}).icon ? mask : findIconDefinition(mask || {});
    }

    return next(iconDefinition, _objectSpread({}, params, {
      mask: mask
    }));
  };
}

var library = new Library();
var _cssInserted = false;
var parse = {
  transform: function transform(transformString) {
    return parseTransformString(transformString);
  }
};
var icon = resolveIcons(function (iconDefinition) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _params$transform = params.transform,
      transform = _params$transform === void 0 ? meaninglessTransform : _params$transform,
      _params$symbol = params.symbol,
      symbol = _params$symbol === void 0 ? false : _params$symbol,
      _params$mask = params.mask,
      mask = _params$mask === void 0 ? null : _params$mask,
      _params$title = params.title,
      title = _params$title === void 0 ? null : _params$title,
      _params$classes = params.classes,
      classes = _params$classes === void 0 ? [] : _params$classes,
      _params$attributes = params.attributes,
      attributes = _params$attributes === void 0 ? {} : _params$attributes,
      _params$styles = params.styles,
      styles = _params$styles === void 0 ? {} : _params$styles;
  if (!iconDefinition) return;
  var prefix = iconDefinition.prefix,
      iconName = iconDefinition.iconName,
      icon = iconDefinition.icon;
  return apiObject(_objectSpread({
    type: 'icon'
  }, iconDefinition), function () {
    ensureCss();

    if (config.autoA11y) {
      if (title) {
        attributes['aria-labelledby'] = "".concat(config.replacementClass, "-title-").concat(nextUniqueId());
      } else {
        attributes['aria-hidden'] = 'true';
        attributes['focusable'] = 'false';
      }
    }

    return makeInlineSvgAbstract({
      icons: {
        main: prepIcon(icon),
        mask: mask ? prepIcon(mask.icon) : {
          found: false,
          width: null,
          height: null,
          icon: {}
        }
      },
      prefix: prefix,
      iconName: iconName,
      transform: _objectSpread({}, meaninglessTransform, transform),
      symbol: symbol,
      title: title,
      extra: {
        attributes: attributes,
        styles: styles,
        classes: classes
      }
    });
  });
});

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var stateshot = createCommonjsModule(function (module, exports) {

Object.defineProperty(exports, '__esModule', { value: true });

// See https://github.com/garycourt/murmurhash-js
var murmurHash2 = function murmurHash2(str) {
  var seed = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  var l = str.length;
  var h = seed ^ l;
  var i = 0;
  var k = void 0;

  while (l >= 4) {
    k = str.charCodeAt(i) & 0xff | (str.charCodeAt(++i) & 0xff) << 8 | (str.charCodeAt(++i) & 0xff) << 16 | (str.charCodeAt(++i) & 0xff) << 24;
    k = (k & 0xffff) * 0x5bd1e995 + (((k >>> 16) * 0x5bd1e995 & 0xffff) << 16);
    k ^= k >>> 24;
    k = (k & 0xffff) * 0x5bd1e995 + (((k >>> 16) * 0x5bd1e995 & 0xffff) << 16);

    h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16) ^ k;

    l -= 4;
    ++i;
  }

  /* eslint-disable no-fallthrough */
  switch (l) {
    case 3:
      h ^= (str.charCodeAt(i + 2) & 0xff) << 16;
    case 2:
      h ^= (str.charCodeAt(i + 1) & 0xff) << 8;
    case 1:
      h ^= str.charCodeAt(i) & 0xff;
      h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16);
  }

  h ^= h >>> 13;
  h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16);
  h ^= h >>> 15;

  return h >>> 0;
};

var hashFunc = murmurHash2;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var defaultRule = {
  // StateNode => { Chunks, Children }
  toRecord: function toRecord(node) {
    return {
      chunks: [_extends({}, node, { children: undefined })], children: node.children
    };
  },
  // { Chunks, Children } => StateNode
  fromRecord: function fromRecord(_ref) {
    var chunks = _ref.chunks,
        children = _ref.children;
    return _extends({}, chunks[0], { children: children });
  }
};

var state2Record = function state2Record(stateNode, chunkPool) {
  var rules = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var prevRecord = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  var pickIndex = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : -1;

  var ruleIndex = rules.findIndex(function (_ref2) {
    var match = _ref2.match;
    return match(stateNode);
  });
  var rule = rules[ruleIndex] || defaultRule;

  var _rule$toRecord = rule.toRecord(stateNode),
      chunks = _rule$toRecord.chunks,
      children = _rule$toRecord.children;

  var recordChildren = children;
  var hashes = [];
  for (var i = 0; i < chunks.length; i++) {
    var chunkStr = JSON.stringify(chunks[i]);
    var hashKey = hashFunc(chunkStr);
    hashes.push(hashKey);
    chunkPool[hashKey] = chunkStr;
  }

  if (pickIndex !== -1 && Array.isArray(prevRecord && prevRecord.children)) {
    var childrenCopy = [].concat(_toConsumableArray(prevRecord.children));
    childrenCopy[pickIndex] = state2Record(recordChildren[pickIndex], chunkPool, rules);
    return { hashes: hashes, ruleIndex: ruleIndex, children: childrenCopy };
  } else {
    return {
      hashes: hashes,
      ruleIndex: ruleIndex,
      children: children && children.map(function (node) {
        return state2Record(node, chunkPool, rules);
      })
    };
  }
};

var record2State = function record2State(recordNode, chunkPool) {
  var rules = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var hashes = recordNode.hashes,
      ruleIndex = recordNode.ruleIndex,
      children = recordNode.children;

  var chunks = hashes.map(function (hash) {
    return JSON.parse(chunkPool[hash]);
  });
  var rule = rules[ruleIndex] || defaultRule;
  return rule.fromRecord({
    chunks: chunks,
    children: children && children.map(function (node) {
      return record2State(node, chunkPool, rules);
    })
  });
};

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var noop = function noop() {};
var History = function () {
  function History() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      rules: [],
      delay: 50,
      maxLength: 100,
      onChange: noop,
      useChunks: true
    };

    _classCallCheck(this, History);

    this.rules = options.rules || [];
    this.delay = options.delay || 50;
    this.maxLength = options.maxLength || 100;
    this.useChunks = options.useChunks === undefined ? true : options.useChunks;
    this.onChange = options.onChange || noop;

    this.$index = -1;
    this.$records = [];
    this.$chunks = {};

    this.$pending = {
      state: null, pickIndex: null, onResolves: [], timer: null
    };
    this.$debounceTime = null;
  }

  // : boolean


  _createClass(History, [{
    key: 'get',


    // void => State
    value: function get() {
      var currentRecord = this.$records[this.$index];
      var resultState = void 0;
      if (!currentRecord) {
        resultState = null;
      } else if (!this.useChunks) {
        resultState = currentRecord;
      } else {
        resultState = record2State(currentRecord, this.$chunks, this.rules);
      }
      this.onChange(resultState);
      return resultState;
    }

    // (State, number?) => History

  }, {
    key: 'pushSync',
    value: function pushSync(state) {
      var _this = this;

      var pickIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;

      var latestRecord = this.$records[this.$index] || null;
      var record = this.useChunks ? state2Record(state, this.$chunks, this.rules, latestRecord, pickIndex) : state;
      this.$index++;
      this.$records[this.$index] = record;
      // Clear redo records.
      for (var i = this.$index + 1; i < this.$records.length; i++) {
        this.$records[i] = null;
      }
      // Clear first valid record if max length reached.
      if (this.$index >= this.maxLength) {
        this.$records[this.$index - this.maxLength] = null;
      }

      // Clear pending state.
      if (this.$pending.timer) {
        clearTimeout(this.$pending.timer);
        this.$pending.state = null;
        this.$pending.pickIndex = null;
        this.$pending.timer = null;
        this.$debounceTime = null;
        this.$pending.onResolves.forEach(function (resolve) {
          return resolve(_this);
        });
        this.$pending.onResolves = [];
      }

      this.onChange(state);
      return this;
    }

    // (State, number?) => Promise<History>

  }, {
    key: 'push',
    value: function push(state) {
      var _this2 = this;

      var pickIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;

      var currentTime = +new Date();
      var setupPending = function setupPending() {
        _this2.$pending.state = state;
        _this2.$pending.pickIndex = pickIndex;
        _this2.$debounceTime = currentTime;
        var promise = new Promise(function (resolve, reject) {
          _this2.$pending.onResolves.push(resolve);
          _this2.$pending.timer = setTimeout(function () {
            _this2.pushSync(_this2.$pending.state, _this2.$pending.pickIndex);
          }, _this2.delay);
        });
        return promise;
      };
      // First time called.
      if (this.$pending.timer === null) {
        return setupPending();
      } else if (currentTime - this.$debounceTime < this.delay) {
        // Has been called without resolved.
        clearTimeout(this.$pending.timer);
        this.$pending.timer = null;
        return setupPending();
      } else return Promise.reject(new Error('Invalid push ops'));
    }

    // void => History

  }, {
    key: 'undo',
    value: function undo() {
      if (this.hasUndo) this.$index--;
      return this;
    }

    // void => History

  }, {
    key: 'redo',
    value: function redo() {
      if (this.hasRedo) this.$index++;
      return this;
    }

    // void => History

  }, {
    key: 'reset',
    value: function reset() {
      var _this3 = this;

      this.$index = -1;
      this.$records.forEach(function (tree) {
      });
      Object.keys(this.$chunks).forEach(function (key) {
        _this3.$chunks[key] = null;
      });
      this.$records = [];
      this.$chunks = {};
      clearTimeout(this.$pending.timer);
      this.$pending = {
        state: null, pickIndex: null, onResolves: [], timer: null
      };
      this.$debounceTime = null;
      return this;
    }
  }, {
    key: 'hasRedo',
    get: function get() {
      // No redo when pointing to last record.
      if (this.$index === this.$records.length - 1) return false;

      // Only has redo if there're valid records after index.
      // There can be no redo even if index less than records' length,
      // when we undo multi records then push a new one.
      var hasRecordAfterIndex = false;
      for (var i = this.$index + 1; i < this.$records.length; i++) {
        if (this.$records[i] !== null) hasRecordAfterIndex = true;
      }
      return hasRecordAfterIndex;
    }

    // : boolean

  }, {
    key: 'hasUndo',
    get: function get() {
      // Only has undo if we have records before index.
      var lowerBound = Math.max(this.$records.length - this.maxLength, 0);
      return this.$index > lowerBound;
    }

    // : number

  }, {
    key: 'length',
    get: function get() {
      return Math.min(this.$records.length, this.maxLength);
    }
  }]);

  return History;
}();

/**
 * Stateshot.js
 * (c) 2018 Yifeng Wang
 */

exports.History = History;

});

unwrapExports(stateshot);
var stateshot_1 = stateshot.History;

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty$2(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty$2(target, key, source[key]);
    });
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _toConsumableArray$1(arr) {
  return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _nonIterableSpread$1();
}

function _arrayWithoutHoles$1(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _iterableToArray$1(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread$1() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function createCommonjsModule$1(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var humps = createCommonjsModule$1(function (module) {
(function(global) {

  var _processKeys = function(convert, obj, options) {
    if(!_isObject(obj) || _isDate(obj) || _isRegExp(obj) || _isBoolean(obj) || _isFunction(obj)) {
      return obj;
    }

    var output,
        i = 0,
        l = 0;

    if(_isArray(obj)) {
      output = [];
      for(l=obj.length; i<l; i++) {
        output.push(_processKeys(convert, obj[i], options));
      }
    }
    else {
      output = {};
      for(var key in obj) {
        if(Object.prototype.hasOwnProperty.call(obj, key)) {
          output[convert(key, options)] = _processKeys(convert, obj[key], options);
        }
      }
    }
    return output;
  };

  // String conversion methods

  var separateWords = function(string, options) {
    options = options || {};
    var separator = options.separator || '_';
    var split = options.split || /(?=[A-Z])/;

    return string.split(split).join(separator);
  };

  var camelize = function(string) {
    if (_isNumerical(string)) {
      return string;
    }
    string = string.replace(/[\-_\s]+(.)?/g, function(match, chr) {
      return chr ? chr.toUpperCase() : '';
    });
    // Ensure 1st char is always lowercase
    return string.substr(0, 1).toLowerCase() + string.substr(1);
  };

  var pascalize = function(string) {
    var camelized = camelize(string);
    // Ensure 1st char is always uppercase
    return camelized.substr(0, 1).toUpperCase() + camelized.substr(1);
  };

  var decamelize = function(string, options) {
    return separateWords(string, options).toLowerCase();
  };

  // Utilities
  // Taken from Underscore.js

  var toString = Object.prototype.toString;

  var _isFunction = function(obj) {
    return typeof(obj) === 'function';
  };
  var _isObject = function(obj) {
    return obj === Object(obj);
  };
  var _isArray = function(obj) {
    return toString.call(obj) == '[object Array]';
  };
  var _isDate = function(obj) {
    return toString.call(obj) == '[object Date]';
  };
  var _isRegExp = function(obj) {
    return toString.call(obj) == '[object RegExp]';
  };
  var _isBoolean = function(obj) {
    return toString.call(obj) == '[object Boolean]';
  };

  // Performant way to determine if obj coerces to a number
  var _isNumerical = function(obj) {
    obj = obj - 0;
    return obj === obj;
  };

  // Sets up function which handles processing keys
  // allowing the convert function to be modified by a callback
  var _processor = function(convert, options) {
    var callback = options && 'process' in options ? options.process : options;

    if(typeof(callback) !== 'function') {
      return convert;
    }

    return function(string, options) {
      return callback(string, convert, options);
    }
  };

  var humps = {
    camelize: camelize,
    decamelize: decamelize,
    pascalize: pascalize,
    depascalize: decamelize,
    camelizeKeys: function(object, options) {
      return _processKeys(_processor(camelize, options), object);
    },
    decamelizeKeys: function(object, options) {
      return _processKeys(_processor(decamelize, options), object, options);
    },
    pascalizeKeys: function(object, options) {
      return _processKeys(_processor(pascalize, options), object);
    },
    depascalizeKeys: function () {
      return this.decamelizeKeys.apply(this, arguments);
    }
  };

  if (module.exports) {
    module.exports = humps;
  } else {
    global.humps = humps;
  }

})(commonjsGlobal);
});

function capitalize(val) {
  return val.charAt(0).toUpperCase() + val.slice(1);
}

function styleToObject(style) {
  return style.split(';').map(function (s) {
    return s.trim();
  }).filter(function (s) {
    return s;
  }).reduce(function (acc, pair) {
    var i = pair.indexOf(':');
    var prop = humps.camelize(pair.slice(0, i));
    var value = pair.slice(i + 1).trim();
    prop.startsWith('webkit') ? acc[capitalize(prop)] = value : acc[prop] = value;
    return acc;
  }, {});
}

function convert(createElement, element) {
  var extraProps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (typeof element === 'string') {
    return element;
  }

  var children = (element.children || []).map(function (child) {
    return convert(createElement, child);
  });
  var mixins = Object.keys(element.attributes || {}).reduce(function (acc, key) {
    var val = element.attributes[key];

    switch (key) {
      case 'class':
        acc.attrs['className'] = val;
        delete element.attributes['class'];
        break;

      case 'style':
        acc.attrs['style'] = styleToObject(val);
        break;

      default:
        if (key.indexOf('aria-') === 0 || key.indexOf('data-') === 0) {
          acc.attrs[key.toLowerCase()] = val;
        } else {
          acc.attrs[humps.camelize(key)] = val;
        }

    }

    return acc;
  }, {
    attrs: {}
  });

  var _extraProps$style = extraProps.style,
      existingStyle = _extraProps$style === void 0 ? {} : _extraProps$style,
      remaining = _objectWithoutProperties(extraProps, ["style"]);

  mixins.attrs['style'] = _objectSpread$1({}, mixins.attrs['style'], existingStyle);
  return createElement.apply(void 0, [element.tag, _objectSpread$1({}, mixins.attrs, remaining)].concat(_toConsumableArray$1(children)));
}

var PRODUCTION$1 = false;

try {
  PRODUCTION$1 = process.env.NODE_ENV === 'production';
} catch (e) {}

function log () {
  if (!PRODUCTION$1 && console && typeof console.error === 'function') {
    var _console;

    (_console = console).error.apply(_console, arguments);
  }
}

function objectWithKey(key, value) {
  return Array.isArray(value) && value.length > 0 || !Array.isArray(value) && value ? _defineProperty$2({}, key, value) : {};
}

function classList(props) {
  var _classes;

  var classes = (_classes = {
    'fa-spin': props.spin,
    'fa-pulse': props.pulse,
    'fa-fw': props.fixedWidth,
    'fa-inverse': props.inverse,
    'fa-border': props.border,
    'fa-li': props.listItem,
    'fa-flip-horizontal': props.flip === 'horizontal' || props.flip === 'both',
    'fa-flip-vertical': props.flip === 'vertical' || props.flip === 'both'
  }, _defineProperty$2(_classes, "fa-".concat(props.size), props.size !== null), _defineProperty$2(_classes, "fa-rotate-".concat(props.rotation), props.rotation !== null), _defineProperty$2(_classes, "fa-pull-".concat(props.pull), props.pull !== null), _classes);
  return Object.keys(classes).map(function (key) {
    return classes[key] ? key : null;
  }).filter(function (key) {
    return key;
  });
}

function normalizeIconArgs(icon$$1) {
  if (icon$$1 === null) {
    return null;
  }

  if (_typeof(icon$$1) === 'object' && icon$$1.prefix && icon$$1.iconName) {
    return icon$$1;
  }

  if (Array.isArray(icon$$1) && icon$$1.length === 2) {
    return {
      prefix: icon$$1[0],
      iconName: icon$$1[1]
    };
  }

  if (typeof icon$$1 === 'string') {
    return {
      prefix: 'fas',
      iconName: icon$$1
    };
  }
}

function FontAwesomeIcon(props) {
  var iconArgs = props.icon,
      maskArgs = props.mask,
      symbol = props.symbol,
      className = props.className,
      title = props.title;
  var iconLookup = normalizeIconArgs(iconArgs);
  var classes = objectWithKey('classes', [].concat(_toConsumableArray$1(classList(props)), _toConsumableArray$1(className.split(' '))));
  var transform = objectWithKey('transform', typeof props.transform === 'string' ? parse.transform(props.transform) : props.transform);
  var mask = objectWithKey('mask', normalizeIconArgs(maskArgs));
  var renderedIcon = icon(iconLookup, _objectSpread$1({}, classes, transform, mask, {
    symbol: symbol,
    title: title
  }));

  if (!renderedIcon) {
    log('Could not find icon', iconLookup);
    return null;
  }

  var abstract = renderedIcon.abstract;
  var extraProps = {};
  Object.keys(props).forEach(function (key) {
    if (!FontAwesomeIcon.defaultProps.hasOwnProperty(key)) {
      extraProps[key] = props[key];
    }
  });
  return convertCurry(abstract[0], extraProps);
}
FontAwesomeIcon.displayName = 'FontAwesomeIcon';
FontAwesomeIcon.propTypes = {
  border: PropTypes.bool,
  className: PropTypes.string,
  mask: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
  fixedWidth: PropTypes.bool,
  inverse: PropTypes.bool,
  flip: PropTypes.oneOf(['horizontal', 'vertical', 'both']),
  icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
  listItem: PropTypes.bool,
  pull: PropTypes.oneOf(['right', 'left']),
  pulse: PropTypes.bool,
  rotation: PropTypes.oneOf([90, 180, 270]),
  size: PropTypes.oneOf(['lg', 'xs', 'sm', '1x', '2x', '3x', '4x', '5x', '6x', '7x', '8x', '9x', '10x']),
  spin: PropTypes.bool,
  symbol: PropTypes.oneOfType([PropTypes.bool, PropTypes.string]),
  title: PropTypes.string,
  transform: PropTypes.oneOfType([PropTypes.string, PropTypes.object])
};
FontAwesomeIcon.defaultProps = {
  border: false,
  className: '',
  mask: null,
  fixedWidth: false,
  inverse: false,
  flip: null,
  icon: null,
  listItem: false,
  pull: null,
  pulse: false,
  rotation: null,
  size: null,
  spin: false,
  symbol: false,
  title: '',
  transform: null
};
var convertCurry = convert.bind(null, React__default.createElement);

var obj;
var NOTHING = typeof Symbol !== "undefined" ? Symbol("immer-nothing") : ( obj = {}, obj["immer-nothing"] = true, obj );
var DRAFTABLE = typeof Symbol !== "undefined" && Symbol.for ? Symbol.for("immer-draftable") : "__$immer_draftable";
var DRAFT_STATE = typeof Symbol !== "undefined" && Symbol.for ? Symbol.for("immer-state") : "__$immer_state";
function isDraft(value) {
  return !!value && !!value[DRAFT_STATE];
}
function isDraftable(value) {
  if (!value || typeof value !== "object") { return false; }
  if (Array.isArray(value)) { return true; }
  var proto = Object.getPrototypeOf(value);
  if (!proto || proto === Object.prototype) { return true; }
  return !!value[DRAFTABLE] || !!value.constructor[DRAFTABLE];
}
var assign = Object.assign || function assign(target, value) {
  for (var key in value) {
    if (has(value, key)) {
      target[key] = value[key];
    }
  }

  return target;
};
var ownKeys$1 = typeof Reflect !== "undefined" && Reflect.ownKeys ? Reflect.ownKeys : typeof Object.getOwnPropertySymbols !== "undefined" ? function (obj) { return Object.getOwnPropertyNames(obj).concat(Object.getOwnPropertySymbols(obj)); } : Object.getOwnPropertyNames;
function shallowCopy(base, invokeGetters) {
  if ( invokeGetters === void 0 ) invokeGetters = false;

  if (Array.isArray(base)) { return base.slice(); }
  var clone = Object.create(Object.getPrototypeOf(base));
  ownKeys$1(base).forEach(function (key) {
    if (key === DRAFT_STATE) {
      return; // Never copy over draft state.
    }

    var desc = Object.getOwnPropertyDescriptor(base, key);
    var value = desc.value;

    if (desc.get) {
      if (!invokeGetters) {
        throw new Error("Immer drafts cannot have computed properties");
      }

      value = desc.get.call(base);
    }

    if (desc.enumerable) {
      clone[key] = value;
    } else {
      Object.defineProperty(clone, key, {
        value: value,
        writable: true,
        configurable: true
      });
    }
  });
  return clone;
}
function each(value, cb) {
  if (Array.isArray(value)) {
    for (var i = 0; i < value.length; i++) { cb(i, value[i], value); }
  } else {
    ownKeys$1(value).forEach(function (key) { return cb(key, value[key], value); });
  }
}
function isEnumerable(base, prop) {
  var desc = Object.getOwnPropertyDescriptor(base, prop);
  return !!desc && desc.enumerable;
}
function has(thing, prop) {
  return Object.prototype.hasOwnProperty.call(thing, prop);
}
function is(x, y) {
  // From: https://github.com/facebook/fbjs/blob/c69904a511b900266935168223063dd8772dfc40/packages/fbjs/src/core/shallowEqual.js
  if (x === y) {
    return x !== 0 || 1 / x === 1 / y;
  } else {
    return x !== x && y !== y;
  }
}

/** Each scope represents a `produce` call. */

var ImmerScope = function ImmerScope(parent) {
  this.drafts = [];
  this.parent = parent; // Whenever the modified draft contains a draft from another scope, we
  // need to prevent auto-freezing so the unowned draft can be finalized.

  this.canAutoFreeze = true; // To avoid prototype lookups:

  this.patches = null;
};

ImmerScope.prototype.usePatches = function usePatches (patchListener) {
  if (patchListener) {
    this.patches = [];
    this.inversePatches = [];
    this.patchListener = patchListener;
  }
};

ImmerScope.prototype.revoke = function revoke$1 () {
  this.leave();
  this.drafts.forEach(revoke);
  this.drafts = null; // Make draft-related methods throw.
};

ImmerScope.prototype.leave = function leave () {
  if (this === ImmerScope.current) {
    ImmerScope.current = this.parent;
  }
};
ImmerScope.current = null;

ImmerScope.enter = function () {
  return this.current = new ImmerScope(this.current);
};

function revoke(draft) {
  draft[DRAFT_STATE].revoke();
}

// but share them all instead

var descriptors = {};
function willFinalize(scope, result, isReplaced) {
  scope.drafts.forEach(function (draft) {
    draft[DRAFT_STATE].finalizing = true;
  });

  if (!isReplaced) {
    if (scope.patches) {
      markChangesRecursively(scope.drafts[0]);
    } // This is faster when we don't care about which attributes changed.


    markChangesSweep(scope.drafts);
  } // When a child draft is returned, look for changes.
  else if (isDraft(result) && result[DRAFT_STATE].scope === scope) {
      markChangesSweep(scope.drafts);
    }
}
function createProxy(base, parent) {
  var isArray = Array.isArray(base);
  var draft = clonePotentialDraft(base);
  each(draft, function (prop) {
    proxyProperty(draft, prop, isArray || isEnumerable(base, prop));
  }); // See "proxy.js" for property documentation.

  var scope = parent ? parent.scope : ImmerScope.current;
  var state = {
    scope: scope,
    modified: false,
    finalizing: false,
    // es5 only
    finalized: false,
    assigned: {},
    parent: parent,
    base: base,
    draft: draft,
    copy: null,
    revoke: revoke$1,
    revoked: false // es5 only

  };
  createHiddenProperty(draft, DRAFT_STATE, state);
  scope.drafts.push(draft);
  return draft;
}

function revoke$1() {
  this.revoked = true;
}

function source(state) {
  return state.copy || state.base;
} // Access a property without creating an Immer draft.


function peek(draft, prop) {
  var state = draft[DRAFT_STATE];

  if (state && !state.finalizing) {
    state.finalizing = true;
    var value = draft[prop];
    state.finalizing = false;
    return value;
  }

  return draft[prop];
}

function get(state, prop) {
  assertUnrevoked(state);
  var value = peek(source(state), prop);
  if (state.finalizing) { return value; } // Create a draft if the value is unmodified.

  if (value === peek(state.base, prop) && isDraftable(value)) {
    prepareCopy(state);
    return state.copy[prop] = createProxy(value, state);
  }

  return value;
}

function set(state, prop, value) {
  assertUnrevoked(state);
  state.assigned[prop] = true;

  if (!state.modified) {
    if (is(value, peek(source(state), prop))) { return; }
    markChanged(state);
    prepareCopy(state);
  }

  state.copy[prop] = value;
}

function markChanged(state) {
  if (!state.modified) {
    state.modified = true;
    if (state.parent) { markChanged(state.parent); }
  }
}

function prepareCopy(state) {
  if (!state.copy) { state.copy = clonePotentialDraft(state.base); }
}

function clonePotentialDraft(base) {
  var state = base && base[DRAFT_STATE];

  if (state) {
    state.finalizing = true;
    var draft = shallowCopy(state.draft, true);
    state.finalizing = false;
    return draft;
  }

  return shallowCopy(base);
}

function proxyProperty(draft, prop, enumerable) {
  var desc = descriptors[prop];

  if (desc) {
    desc.enumerable = enumerable;
  } else {
    descriptors[prop] = desc = {
      configurable: true,
      enumerable: enumerable,

      get: function get$1() {
        return get(this[DRAFT_STATE], prop);
      },

      set: function set$1(value) {
        set(this[DRAFT_STATE], prop, value);
      }

    };
  }

  Object.defineProperty(draft, prop, desc);
}

function assertUnrevoked(state) {
  if (state.revoked === true) { throw new Error("Cannot use a proxy that has been revoked. Did you pass an object from inside an immer function to an async process? " + JSON.stringify(source(state))); }
} // This looks expensive, but only proxies are visited, and only objects without known changes are scanned.


function markChangesSweep(drafts) {
  // The natural order of drafts in the `scope` array is based on when they
  // were accessed. By processing drafts in reverse natural order, we have a
  // better chance of processing leaf nodes first. When a leaf node is known to
  // have changed, we can avoid any traversal of its ancestor nodes.
  for (var i = drafts.length - 1; i >= 0; i--) {
    var state = drafts[i][DRAFT_STATE];

    if (!state.modified) {
      if (Array.isArray(state.base)) {
        if (hasArrayChanges(state)) { markChanged(state); }
      } else if (hasObjectChanges(state)) { markChanged(state); }
    }
  }
}

function markChangesRecursively(object) {
  if (!object || typeof object !== "object") { return; }
  var state = object[DRAFT_STATE];
  if (!state) { return; }
  var base = state.base;
  var draft = state.draft;
  var assigned = state.assigned;

  if (!Array.isArray(object)) {
    // Look for added keys.
    Object.keys(draft).forEach(function (key) {
      // The `undefined` check is a fast path for pre-existing keys.
      if (base[key] === undefined && !has(base, key)) {
        assigned[key] = true;
        markChanged(state);
      } else if (!assigned[key]) {
        // Only untouched properties trigger recursion.
        markChangesRecursively(draft[key]);
      }
    }); // Look for removed keys.

    Object.keys(base).forEach(function (key) {
      // The `undefined` check is a fast path for pre-existing keys.
      if (draft[key] === undefined && !has(draft, key)) {
        assigned[key] = false;
        markChanged(state);
      }
    });
  } else if (hasArrayChanges(state)) {
    markChanged(state);
    assigned.length = true;

    if (draft.length < base.length) {
      for (var i = draft.length; i < base.length; i++) { assigned[i] = false; }
    } else {
      for (var i$1 = base.length; i$1 < draft.length; i$1++) { assigned[i$1] = true; }
    }

    for (var i$2 = 0; i$2 < draft.length; i$2++) {
      // Only untouched indices trigger recursion.
      if (assigned[i$2] === undefined) { markChangesRecursively(draft[i$2]); }
    }
  }
}

function hasObjectChanges(state) {
  var base = state.base;
  var draft = state.draft; // Search for added keys and changed keys. Start at the back, because
  // non-numeric keys are ordered by time of definition on the object.

  var keys = Object.keys(draft);

  for (var i = keys.length - 1; i >= 0; i--) {
    var key = keys[i];
    var baseValue = base[key]; // The `undefined` check is a fast path for pre-existing keys.

    if (baseValue === undefined && !has(base, key)) {
      return true;
    } // Once a base key is deleted, future changes go undetected, because its
    // descriptor is erased. This branch detects any missed changes.
    else {
        var value = draft[key];
        var state$1 = value && value[DRAFT_STATE];

        if (state$1 ? state$1.base !== baseValue : !is(value, baseValue)) {
          return true;
        }
      }
  } // At this point, no keys were added or changed.
  // Compare key count to determine if keys were deleted.


  return keys.length !== Object.keys(base).length;
}

function hasArrayChanges(state) {
  var draft = state.draft;
  if (draft.length !== state.base.length) { return true; } // See #116
  // If we first shorten the length, our array interceptors will be removed.
  // If after that new items are added, result in the same original length,
  // those last items will have no intercepting property.
  // So if there is no own descriptor on the last position, we know that items were removed and added
  // N.B.: splice, unshift, etc only shift values around, but not prop descriptors, so we only have to check
  // the last one

  var descriptor = Object.getOwnPropertyDescriptor(draft, draft.length - 1); // descriptor can be null, but only for newly created sparse arrays, eg. new Array(10)

  if (descriptor && !descriptor.get) { return true; } // For all other cases, we don't have to compare, as they would have been picked up by the index setters

  return false;
}

function createHiddenProperty(target, prop, value) {
  Object.defineProperty(target, prop, {
    value: value,
    enumerable: false,
    writable: true
  });
}

var legacyProxy = /*#__PURE__*/Object.freeze({
    willFinalize: willFinalize,
    createProxy: createProxy
});

function willFinalize$1() {}
function createProxy$1(base, parent) {
  var scope = parent ? parent.scope : ImmerScope.current;
  var state = {
    // Track which produce call this is associated with.
    scope: scope,
    // True for both shallow and deep changes.
    modified: false,
    // Used during finalization.
    finalized: false,
    // Track which properties have been assigned (true) or deleted (false).
    assigned: {},
    // The parent draft state.
    parent: parent,
    // The base state.
    base: base,
    // The base proxy.
    draft: null,
    // Any property proxies.
    drafts: {},
    // The base copy with any updated values.
    copy: null,
    // Called by the `produce` function.
    revoke: null
  };
  var ref = Array.isArray(base) ? // [state] is used for arrays, to make sure the proxy is array-ish and not violate invariants,
  // although state itself is an object
  Proxy.revocable([state], arrayTraps) : Proxy.revocable(state, objectTraps);
  var revoke = ref.revoke;
  var proxy = ref.proxy;
  state.draft = proxy;
  state.revoke = revoke;
  scope.drafts.push(proxy);
  return proxy;
}
var objectTraps = {
  get: get$1,

  has: function has(target, prop) {
    return prop in source$1(target);
  },

  ownKeys: function ownKeys(target) {
    return Reflect.ownKeys(source$1(target));
  },

  set: set$1,
  deleteProperty: deleteProperty,
  getOwnPropertyDescriptor: getOwnPropertyDescriptor,

  defineProperty: function defineProperty() {
    throw new Error("Object.defineProperty() cannot be used on an Immer draft"); // prettier-ignore
  },

  getPrototypeOf: function getPrototypeOf(target) {
    return Object.getPrototypeOf(target.base);
  },

  setPrototypeOf: function setPrototypeOf() {
    throw new Error("Object.setPrototypeOf() cannot be used on an Immer draft"); // prettier-ignore
  }

};
var arrayTraps = {};
each(objectTraps, function (key, fn) {
  arrayTraps[key] = function () {
    arguments[0] = arguments[0][0];
    return fn.apply(this, arguments);
  };
});

arrayTraps.deleteProperty = function (state, prop) {
  if (isNaN(parseInt(prop))) {
    throw new Error("Immer only supports deleting array indices"); // prettier-ignore
  }

  return objectTraps.deleteProperty.call(this, state[0], prop);
};

arrayTraps.set = function (state, prop, value) {
  if (prop !== "length" && isNaN(parseInt(prop))) {
    throw new Error("Immer only supports setting array indices and the 'length' property"); // prettier-ignore
  }

  return objectTraps.set.call(this, state[0], prop, value);
}; // returns the object we should be reading the current value from, which is base, until some change has been made


function source$1(state) {
  return state.copy || state.base;
} // Access a property without creating an Immer draft.


function peek$1(draft, prop) {
  var state = draft[DRAFT_STATE];
  var desc = Reflect.getOwnPropertyDescriptor(state ? source$1(state) : draft, prop);
  return desc && desc.value;
}

function get$1(state, prop) {
  if (prop === DRAFT_STATE) { return state; }
  var drafts = state.drafts; // Check for existing draft in unmodified state.

  if (!state.modified && has(drafts, prop)) {
    return drafts[prop];
  }

  var value = source$1(state)[prop];

  if (state.finalized || !isDraftable(value)) {
    return value;
  } // Check for existing draft in modified state.


  if (state.modified) {
    // Assigned values are never drafted. This catches any drafts we created, too.
    if (value !== peek$1(state.base, prop)) { return value; } // Store drafts on the copy (when one exists).

    drafts = state.copy;
  }

  return drafts[prop] = createProxy$1(value, state);
}

function set$1(state, prop, value) {
  if (!state.modified) {
    var baseValue = peek$1(state.base, prop); // Optimize based on value's truthiness. Truthy values are guaranteed to
    // never be undefined, so we can avoid the `in` operator. Lastly, truthy
    // values may be drafts, but falsy values are never drafts.

    var isUnchanged = value ? is(baseValue, value) || value === state.drafts[prop] : is(baseValue, value) && prop in state.base;
    if (isUnchanged) { return true; }
    markChanged$1(state);
  }

  state.assigned[prop] = true;
  state.copy[prop] = value;
  return true;
}

function deleteProperty(state, prop) {
  // The `undefined` check is a fast path for pre-existing keys.
  if (peek$1(state.base, prop) !== undefined || prop in state.base) {
    state.assigned[prop] = false;
    markChanged$1(state);
  }

  if (state.copy) { delete state.copy[prop]; }
  return true;
} // Note: We never coerce `desc.value` into an Immer draft, because we can't make
// the same guarantee in ES5 mode.


function getOwnPropertyDescriptor(state, prop) {
  var owner = source$1(state);
  var desc = Reflect.getOwnPropertyDescriptor(owner, prop);

  if (desc) {
    desc.writable = true;
    desc.configurable = !Array.isArray(owner) || prop !== "length";
  }

  return desc;
}

function markChanged$1(state) {
  if (!state.modified) {
    state.modified = true;
    state.copy = assign(shallowCopy(state.base), state.drafts);
    state.drafts = null;
    if (state.parent) { markChanged$1(state.parent); }
  }
}

var modernProxy = /*#__PURE__*/Object.freeze({
    willFinalize: willFinalize$1,
    createProxy: createProxy$1
});

function generatePatches(state, basePath, patches, inversePatches) {
  Array.isArray(state.base) ? generateArrayPatches(state, basePath, patches, inversePatches) : generateObjectPatches(state, basePath, patches, inversePatches);
}

function generateArrayPatches(state, basePath, patches, inversePatches) {
  var assign, assign$1;

  var base = state.base;
  var copy = state.copy;
  var assigned = state.assigned; // Reduce complexity by ensuring `base` is never longer.

  if (copy.length < base.length) {
    (assign = [copy, base], base = assign[0], copy = assign[1]);
    (assign$1 = [inversePatches, patches], patches = assign$1[0], inversePatches = assign$1[1]);
  }

  var delta = copy.length - base.length; // Find the first replaced index.

  var start = 0;

  while (base[start] === copy[start] && start < base.length) {
    ++start;
  } // Find the last replaced index. Search from the end to optimize splice patches.


  var end = base.length;

  while (end > start && base[end - 1] === copy[end + delta - 1]) {
    --end;
  } // Process replaced indices.


  for (var i = start; i < end; ++i) {
    if (assigned[i] && copy[i] !== base[i]) {
      var path = basePath.concat([i]);
      patches.push({
        op: "replace",
        path: path,
        value: copy[i]
      });
      inversePatches.push({
        op: "replace",
        path: path,
        value: base[i]
      });
    }
  }

  var useRemove = end != base.length;
  var replaceCount = patches.length; // Process added indices.

  for (var i$1 = end + delta - 1; i$1 >= end; --i$1) {
    var path$1 = basePath.concat([i$1]);
    patches[replaceCount + i$1 - end] = {
      op: "add",
      path: path$1,
      value: copy[i$1]
    };

    if (useRemove) {
      inversePatches.push({
        op: "remove",
        path: path$1
      });
    }
  } // One "replace" patch reverses all non-splicing "add" patches.


  if (!useRemove) {
    inversePatches.push({
      op: "replace",
      path: basePath.concat(["length"]),
      value: base.length
    });
  }
}

function generateObjectPatches(state, basePath, patches, inversePatches) {
  var base = state.base;
  var copy = state.copy;
  each(state.assigned, function (key, assignedValue) {
    var origValue = base[key];
    var value = copy[key];
    var op = !assignedValue ? "remove" : key in base ? "replace" : "add";
    if (origValue === value && op === "replace") { return; }
    var path = basePath.concat(key);
    patches.push(op === "remove" ? {
      op: op,
      path: path
    } : {
      op: op,
      path: path,
      value: value
    });
    inversePatches.push(op === "add" ? {
      op: "remove",
      path: path
    } : op === "remove" ? {
      op: "add",
      path: path,
      value: origValue
    } : {
      op: "replace",
      path: path,
      value: origValue
    });
  });
}

function applyPatches(draft, patches) {
  for (var i = 0; i < patches.length; i++) {
    var patch = patches[i];
    var path = patch.path;

    if (path.length === 0 && patch.op === "replace") {
      draft = patch.value;
    } else {
      var base = draft;

      for (var i$1 = 0; i$1 < path.length - 1; i$1++) {
        base = base[path[i$1]];
        if (!base || typeof base !== "object") { throw new Error("Cannot apply patch, path doesn't resolve: " + path.join("/")); } // prettier-ignore
      }

      var key = path[path.length - 1];

      switch (patch.op) {
        case "replace":
          base[key] = patch.value;
          break;

        case "add":
          if (Array.isArray(base)) {
            // TODO: support "foo/-" paths for appending to an array
            base.splice(key, 0, patch.value);
          } else {
            base[key] = patch.value;
          }

          break;

        case "remove":
          if (Array.isArray(base)) {
            base.splice(key, 1);
          } else {
            delete base[key];
          }

          break;

        default:
          throw new Error("Unsupported patch operation: " + patch.op);
      }
    }
  }

  return draft;
}

function verifyMinified() {}

var configDefaults = {
  useProxies: typeof Proxy !== "undefined" && typeof Reflect !== "undefined",
  autoFreeze: typeof process !== "undefined" ? process.env.NODE_ENV !== "production" : verifyMinified.name === "verifyMinified",
  onAssign: null,
  onDelete: null,
  onCopy: null
};
var Immer = function Immer(config) {
  assign(this, configDefaults, config);
  this.setUseProxies(this.useProxies);
  this.produce = this.produce.bind(this);
};

Immer.prototype.produce = function produce (base, recipe, patchListener) {
    var this$1 = this;

  // curried invocation
  if (typeof base === "function" && typeof recipe !== "function") {
    var defaultBase = recipe;
    recipe = base;
    var self = this;
    return function curriedProduce(base) {
        var this$1 = this;
        if ( base === void 0 ) base = defaultBase;
        var args = [], len = arguments.length - 1;
        while ( len-- > 0 ) args[ len ] = arguments[ len + 1 ];

      return self.produce(base, function (draft) { return recipe.call.apply(recipe, [ this$1, draft ].concat( args )); }); // prettier-ignore
    };
  } // prettier-ignore


  {
    if (typeof recipe !== "function") {
      throw new Error("The first or second argument to `produce` must be a function");
    }

    if (patchListener !== undefined && typeof patchListener !== "function") {
      throw new Error("The third argument to `produce` must be a function or undefined");
    }
  }
  var result; // Only plain objects, arrays, and "immerable classes" are drafted.

  if (isDraftable(base)) {
    var scope = ImmerScope.enter();
    var proxy = this.createProxy(base);
    var hasError = true;

    try {
      result = recipe(proxy);
      hasError = false;
    } finally {
      // finally instead of catch + rethrow better preserves original stack
      if (hasError) { scope.revoke(); }else { scope.leave(); }
    }

    if (result instanceof Promise) {
      return result.then(function (result) {
        scope.usePatches(patchListener);
        return this$1.processResult(result, scope);
      }, function (error) {
        scope.revoke();
        throw error;
      });
    }

    scope.usePatches(patchListener);
    return this.processResult(result, scope);
  } else {
    result = recipe(base);
    if (result === undefined) { return base; }
    return result !== NOTHING ? result : undefined;
  }
};

Immer.prototype.createDraft = function createDraft (base) {
  if (!isDraftable(base)) {
    throw new Error("First argument to `createDraft` must be a plain object, an array, or an immerable object"); // prettier-ignore
  }

  var scope = ImmerScope.enter();
  var proxy = this.createProxy(base);
  proxy[DRAFT_STATE].isManual = true;
  scope.leave();
  return proxy;
};

Immer.prototype.finishDraft = function finishDraft (draft, patchListener) {
  var state = draft && draft[DRAFT_STATE];

  if (!state || !state.isManual) {
    throw new Error("First argument to `finishDraft` must be a draft returned by `createDraft`"); // prettier-ignore
  }

  if (state.finalized) {
    throw new Error("The given draft is already finalized"); // prettier-ignore
  }

  var scope = state.scope;
  scope.usePatches(patchListener);
  return this.processResult(undefined, scope);
};

Immer.prototype.setAutoFreeze = function setAutoFreeze (value) {
  this.autoFreeze = value;
};

Immer.prototype.setUseProxies = function setUseProxies (value) {
  this.useProxies = value;
  assign(this, value ? modernProxy : legacyProxy);
};

Immer.prototype.applyPatches = function applyPatches$1 (base, patches) {
  // Mutate the base state when a draft is passed.
  if (isDraft(base)) {
    return applyPatches(base, patches);
  } // Otherwise, produce a copy of the base state.


  return this.produce(base, function (draft) { return applyPatches(draft, patches); });
};
/** @internal */


Immer.prototype.processResult = function processResult (result, scope) {
  var baseDraft = scope.drafts[0];
  var isReplaced = result !== undefined && result !== baseDraft;
  this.willFinalize(scope, result, isReplaced);

  if (isReplaced) {
    if (baseDraft[DRAFT_STATE].modified) {
      scope.revoke();
      throw new Error("An immer producer returned a new value *and* modified its draft. Either return a new value *or* modify the draft."); // prettier-ignore
    }

    if (isDraftable(result)) {
      // Finalize the result in case it contains (or is) a subset of the draft.
      result = this.finalize(result, null, scope);
    }

    if (scope.patches) {
      scope.patches.push({
        op: "replace",
        path: [],
        value: result
      });
      scope.inversePatches.push({
        op: "replace",
        path: [],
        value: baseDraft[DRAFT_STATE].base
      });
    }
  } else {
    // Finalize the base draft.
    result = this.finalize(baseDraft, [], scope);
  }

  scope.revoke();

  if (scope.patches) {
    scope.patchListener(scope.patches, scope.inversePatches);
  }

  return result !== NOTHING ? result : undefined;
};
/**
 * @internal
 * Finalize a draft, returning either the unmodified base state or a modified
 * copy of the base state.
 */


Immer.prototype.finalize = function finalize (draft, path, scope) {
    var this$1 = this;

  var state = draft[DRAFT_STATE];

  if (!state) {
    if (Object.isFrozen(draft)) { return draft; }
    return this.finalizeTree(draft, null, scope);
  } // Never finalize drafts owned by another scope.


  if (state.scope !== scope) {
    return draft;
  }

  if (!state.modified) {
    return state.base;
  }

  if (!state.finalized) {
    state.finalized = true;
    this.finalizeTree(state.draft, path, scope);

    if (this.onDelete) {
      // The `assigned` object is unreliable with ES5 drafts.
      if (this.useProxies) {
        var assigned = state.assigned;

        for (var prop in assigned) {
          if (!assigned[prop]) { this.onDelete(state, prop); }
        }
      } else {
        var base = state.base;
          var copy = state.copy;
        each(base, function (prop) {
          if (!has(copy, prop)) { this$1.onDelete(state, prop); }
        });
      }
    }

    if (this.onCopy) {
      this.onCopy(state);
    } // At this point, all descendants of `state.copy` have been finalized,
    // so we can be sure that `scope.canAutoFreeze` is accurate.


    if (this.autoFreeze && scope.canAutoFreeze) {
      Object.freeze(state.copy);
    }

    if (path && scope.patches) {
      generatePatches(state, path, scope.patches, scope.inversePatches);
    }
  }

  return state.copy;
};
/**
 * @internal
 * Finalize all drafts in the given state tree.
 */


Immer.prototype.finalizeTree = function finalizeTree (root, rootPath, scope) {
    var this$1 = this;

  var state = root[DRAFT_STATE];

  if (state) {
    if (!this.useProxies) {
      // Create the final copy, with added keys and without deleted keys.
      state.copy = shallowCopy(state.draft, true);
    }

    root = state.copy;
  }

  var needPatches = !!rootPath && !!scope.patches;

  var finalizeProperty = function (prop, value, parent) {
    if (value === parent) {
      throw Error("Immer forbids circular references");
    } // In the `finalizeTree` method, only the `root` object may be a draft.


    var isDraftProp = !!state && parent === root;

    if (isDraft(value)) {
      var path = isDraftProp && needPatches && !state.assigned[prop] ? rootPath.concat(prop) : null; // Drafts owned by `scope` are finalized here.

      value = this$1.finalize(value, path, scope); // Drafts from another scope must prevent auto-freezing.

      if (isDraft(value)) {
        scope.canAutoFreeze = false;
      } // Preserve non-enumerable properties.


      if (Array.isArray(parent) || isEnumerable(parent, prop)) {
        parent[prop] = value;
      } else {
        Object.defineProperty(parent, prop, {
          value: value
        });
      } // Unchanged drafts are never passed to the `onAssign` hook.


      if (isDraftProp && value === state.base[prop]) { return; }
    } // Unchanged draft properties are ignored.
    else if (isDraftProp && is(value, state.base[prop])) {
        return;
      } // Search new objects for unfinalized drafts. Frozen objects should never contain drafts.
      else if (isDraftable(value) && !Object.isFrozen(value)) {
          each(value, finalizeProperty);
        }

    if (isDraftProp && this$1.onAssign) {
      this$1.onAssign(state, prop, value);
    }
  };

  each(root, finalizeProperty);
  return root;
};

var immer = new Immer();
/**
 * The `produce` function takes a value and a "recipe function" (whose
 * return value often depends on the base state). The recipe function is
 * free to mutate its first argument however it wants. All mutations are
 * only ever applied to a __copy__ of the base state.
 *
 * Pass only a function to create a "curried producer" which relieves you
 * from passing the recipe function every time.
 *
 * Only plain objects and arrays are made mutable. All other objects are
 * considered uncopyable.
 *
 * Note: This function is __bound__ to its `Immer` instance.
 *
 * @param {any} base - the initial state
 * @param {Function} producer - function that receives a proxy of the base state as first argument and which can be freely modified
 * @param {Function} patchListener - optional function that will be called with all the patches produced here
 * @returns {any} a new state, or the initial state if nothing was modified
 */

var produce = immer.produce;
/**
 * Pass true to automatically freeze all copies created by Immer.
 *
 * By default, auto-freezing is disabled in production.
 */

var setAutoFreeze = immer.setAutoFreeze.bind(immer);
/**
 * Pass true to use the ES2015 `Proxy` class when creating drafts, which is
 * always faster than using ES5 proxies.
 *
 * By default, feature detection is used, so calling this is rarely necessary.
 */

var setUseProxies = immer.setUseProxies.bind(immer);
/**
 * Apply an array of Immer patches to the first argument.
 *
 * This function is a producer, which means copy-on-write is in effect.
 */

var applyPatches$1 = immer.applyPatches.bind(immer);
/**
 * Create an Immer draft from the given base state, which may be a draft itself.
 * The draft can be modified until you finalize it with the `finishDraft` function.
 */

var createDraft = immer.createDraft.bind(immer);
/**
 * Finalize an Immer draft from a `createDraft` call, returning the base state
 * (if no changes were made) or a modified copy. The draft must *not* be
 * mutated afterwards.
 *
 * Pass a function as the 2nd argument to generate Immer patches based on the
 * changes that were made.
 */

var finishDraft = immer.finishDraft.bind(immer);

/* eslint-disable no-use-before-define */
function getNodeById(node, id) {
  if (node.id === id) {
    return node;
  }

  if (node.children) {
    for (var i = 0; i < node.children.length; i += 1) {
      var nodeRes = getNodeById(node.children[i], id);

      if (nodeRes) {
        return nodeRes;
      }
    }
  }

  return null;
}
function getParentNodeById(node, id) {
  if (!node.children) {
    return null;
  }

  if (node.children.find(function (x) {
    return x.id === id;
  })) {
    return node;
  }

  for (var i = 0; i < node.children.length; i += 1) {
    var nodeRes = getParentNodeById(node.children[i], id);

    if (nodeRes) {
      return nodeRes;
    }
  }

  return null;
}
function getPasteResultById(config, node, newIdFunc) {
  var copyResult = {
    node: {},
    copyDetail: []
  };
  var copydNode = node;
  var newIds = [];

  var processcopydNode = function processcopydNode(node1) {
    var prevId = node1.id;
    var nextId = newIdFunc(newIds);
    newIds.push(nextId);
    node1.id = nextId;
    copyResult.copyDetail.push({
      from: prevId,
      to: nextId
    });

    if (node1.children) {
      for (var i = 0; i < node1.children.length; i += 1) {
        processcopydNode(node1.children[i]);
      }
    }
  };

  processcopydNode(copydNode);
  copyResult.node = copydNode;
  return copyResult;
}
function getcopyResultById(config, id, newIdFunc) {
  var copyResult = {
    node: {},
    copyDetail: []
  };
  var sourceNode = getNodeById(config, id);
  var str = JSON.stringify(sourceNode);
  var copydNode = JSON.parse(str);
  var newIds = [];

  var processcopydNode = function processcopydNode(node) {
    var prevId = node.id;
    var nextId = newIdFunc(newIds);
    newIds.push(nextId);
    node.id = nextId;
    copyResult.copyDetail.push({
      from: prevId,
      to: nextId
    });

    if (node.children) {
      for (var i = 0; i < node.children.length; i += 1) {
        processcopydNode(node.children[i]);
      }
    }
  };

  processcopydNode(copydNode);
  copyResult.node = copydNode;
  return copyResult;
}
/**
 *
 * @param {*} param0
 */

function getNewFlowByAdd(_ref) {
  var config = _ref.config,
      node = _ref.node,
      containerId = _ref.containerId,
      containerIndex = _ref.containerIndex;
  var flow = produce(config, function (draft) {
    var containerNode = getNodeById(draft, containerId);

    if (containerNode.type === 'switch') {
      return;
    }

    if (!containerNode.children) {
      containerNode.children = [];
    }

    containerNode.children.splice(containerIndex, 0, node);
  });
  var nodes = getAllId(node);
  return {
    flow: flow,
    nodes: nodes
  };
}
function getAllId(node) {
  var ids = [];

  var pushId = function pushId(n) {
    ids.push(n.id);

    if (n.children && n.children.length) {
      for (var i = 0; i < n.children.length; i += 1) {
        pushId(n.children[i]);
      }
    }
  };

  pushId(node);
  return ids;
}
/**
 *
 * @param {*} param0
 */

function getNewFlowByDel(_ref2) {
  var config = _ref2.config,
      sourceId = _ref2.sourceId;
  var nodes = [];
  var flow = produce(config, function (draft) {
    var sourceParentNode = getParentNodeById(draft, sourceId);
    var sourceIndex = sourceParentNode.children.findIndex(function (x) {
      return x.id === sourceId;
    });
    var sourceNode = sourceParentNode.children[sourceIndex];

    if (sourceNode.children && sourceNode.children.length) {
      var shouldDeleteNodeIds = getAllId(sourceNode);

      for (var i = 0; i < shouldDeleteNodeIds.length; i += 1) {
        nodes.push(shouldDeleteNodeIds[i]);
      }
    }

    sourceParentNode.children.splice(sourceIndex, 1);

    if (sourceNode.type === 'case' && !sourceParentNode.children.length) {
      var switchParentNode = getParentNodeById(draft, sourceParentNode.id);
      var switchIndex = switchParentNode.children.findIndex(function (x) {
        return x.id === sourceParentNode.id;
      });
      switchParentNode.children.splice(switchIndex, 1);
      nodes.push(sourceParentNode.id);
    }
  });
  return {
    flow: flow,
    nodes: nodes
  };
}
function getNewFlowByMove(_ref3) {
  var config = _ref3.config,
      sourceId = _ref3.sourceId,
      containerId = _ref3.containerId,
      containerIndex = _ref3.containerIndex;
  var nodes = [];
  var flow = produce(config, function (draft) {
    var sourceParentNode = getParentNodeById(draft, sourceId);
    var sourceIndex = sourceParentNode.children.findIndex(function (x) {
      return x.id === sourceId;
    });
    var sourceNode = sourceParentNode.children[sourceIndex];
    nodes = getAllId(sourceNode);
    var containerNode = getNodeById(draft, containerId);

    if (sourceNode.type === 'case' && containerNode.type !== 'switch') {
      return;
    }

    if (sourceNode.type !== 'case' && containerNode.type === 'switch') {
      return;
    }

    var newIndex = containerId === sourceParentNode.id && containerIndex > sourceIndex ? containerIndex - 1 : containerIndex;
    sourceParentNode.children.splice(sourceIndex, 1);
    containerNode.children.splice(newIndex, 0, sourceNode);

    if (sourceNode.type === 'case' && !sourceParentNode.children.length) {
      var node = getParentNodeById(draft, sourceParentNode.id);
      var idnex = node.children.findIndex(function (x) {
        return x.id === sourceParentNode.id;
      });
      node.children.splice(idnex, 1);
    }
  });
  return {
    flow: flow,
    nodes: nodes
  };
}
/**
 *
 * @param {*} param0
 */

function getNewFlowByPaste(_ref4) {
  var config = _ref4.config,
      sourceNode = _ref4.sourceNode,
      containerId = _ref4.containerId,
      containerIndex = _ref4.containerIndex;
  var copyDetail = [];
  var data = produce(config, function (draft) {
    var containerNode = getNodeById(draft, containerId);
    var copyResult = getPasteResultById(config, sourceNode, getNewIdFunc(config));
    copyDetail = copyResult.copyDetail;
    containerNode.children.splice(containerIndex, 0, copyResult.node);
  });
  return {
    data: data,
    copyDetail: copyDetail
  };
}
/**
 *
 * @param {*} param0
 */

function getNewFlowByCopy(_ref5) {
  var config = _ref5.config,
      sourceId = _ref5.sourceId,
      containerId = _ref5.containerId,
      containerIndex = _ref5.containerIndex;
  var copyDetail = [];
  var data = produce(config, function (draft) {
    var sourceParentNode = getParentNodeById(draft, sourceId);
    var sourceIndex = sourceParentNode.children.findIndex(function (x) {
      return x.id === sourceId;
    });
    var sourceNode = sourceParentNode.children[sourceIndex];
    var containerNode = getNodeById(draft, containerId); //

    if (sourceNode.type === 'case' && containerNode.type !== 'switch') {
      return;
    }

    if (sourceNode.type !== 'case' && containerNode.type === 'switch') {
      return;
    }

    var copyResult = getcopyResultById(config, sourceId, getNewIdFunc(config));
    copyDetail = copyResult.copyDetail;
    containerNode.children.splice(containerIndex, 0, copyResult.node);
  });
  return {
    data: data,
    copyDetail: copyDetail
  };
}
function getNewNode(type, action, name, newIdFunc) {
  var newIds = [];
  var id = newIdFunc(newIds);
  newIds.push(id);
  var newNode = {
    id: id
  };
  newNode.name = name;
  newNode.type = type;
  newNode.action = action;

  if (type === 'loop') {
    newNode.type = 'loop';
    newNode.children = [];
  } else if (type === 'switch') {
    newNode.type = 'switch';
    var caseId1 = newIdFunc(newIds);
    newIds.push(caseId1);
    var caseId2 = newIdFunc(newIds);
    newIds.push(caseId2);
    newNode.children = [{
      id: caseId1,
      type: 'case',
      action: 'case',
      name: "case".concat(caseId1),
      children: []
    }, {
      id: caseId2,
      type: 'case',
      action: 'case',
      name: "case".concat(caseId2),
      children: []
    }];
  }

  return newNode;
}
/**
 * 获取新的节点ID并保证唯一
 * @param {*} flow
 */

var getNewIdFunc = function getNewIdFunc(flow) {
  var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  return function (ids) {
    var prevIds = getAllId(flow);
    var id;
    var index = 0;

    do {
      index += 1;
      id = "".concat(prefix).concat(index);
    } while (prevIds.includes(id) || ids.includes(id));

    return id;
  };
};

var Overlay =
/*#__PURE__*/
function (_Component) {
  _inherits(Overlay, _Component);

  function Overlay() {
    _classCallCheck(this, Overlay);

    return _possibleConstructorReturn(this, _getPrototypeOf(Overlay).apply(this, arguments));
  }

  _createClass(Overlay, [{
    key: "render",
    value: function render() {
      var style = {
        backgroundColor: '#f1f1f1',
        border: '1px solid #e1e1e1',
        padding: '4px',
        visibility: this.props.visible ? 'visible' : 'hidden'
      };
      return React__default.createElement("div", {
        style: style,
        onDragOver: this.props.onDragOver,
        onDragLeave: this.props.onDragLeave,
        onDrop: this.props.onDrop
      }, React__default.createElement(FontAwesomeIcon, {
        icon: "trash-alt",
        style: {
          height: '48px',
          width: '48px'
        }
      }));
    }
  }]);

  return Overlay;
}(React.Component);

_defineProperty(Overlay, "propTypes", {
  visible: PropTypes.bool,
  onDragOver: PropTypes.func,
  onDragLeave: PropTypes.func,
  onDrop: PropTypes.func
});

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css$1 = ".react-workflow-editor-container {\n  background-color: #fff;\n  flex-grow: 1;\n  overflow: auto;\n  border-right: 2px solid #ddd;\n  padding-left: 10px;\n  position: relative; }\n  .react-workflow-editor-container.editor {\n    flex-grow: 1;\n    display: table;\n    padding: 20px;\n    color: black; }\n    .react-workflow-editor-container.editor i {\n      width: 24px;\n      height: 24px; }\n    .react-workflow-editor-container.editor .title {\n      text-align: center;\n      font-size: 14px; }\n    .react-workflow-editor-container.editor .workflow-body {\n      display: flex;\n      flex-direction: column;\n      align-items: center; }\n      .react-workflow-editor-container.editor .workflow-body.root {\n        min-height: 300px;\n        min-width: 400px; }\n        .react-workflow-editor-container.editor .workflow-body.root > .flow-line {\n          flex-grow: 1;\n          display: flex;\n          flex-direction: column; }\n          .react-workflow-editor-container.editor .workflow-body.root > .flow-line > .line {\n            flex-grow: 1; }\n    .react-workflow-editor-container.editor .workflow-node {\n      display: flex;\n      flex-direction: column;\n      align-items: center;\n      min-width: 150px; }\n      .react-workflow-editor-container.editor .workflow-node.normal {\n        color: #fff;\n        border: 0;\n        border-radius: 4px;\n        background-color: #9f9f9f;\n        font-size: 14px;\n        width: 150px;\n        margin: 3px 0;\n        padding: 3px;\n        color: white;\n        box-shadow: 0 0 0 2px white, 0 0 0 3px #8eccbb; }\n        .react-workflow-editor-container.editor .workflow-node.normal.draged {\n          background-color: #d2d2d2; }\n        .react-workflow-editor-container.editor .workflow-node.normal.clicked {\n          outline-offset: 8px;\n          outline: 1px dashed red; }\n      .react-workflow-editor-container.editor .workflow-node.case {\n        margin: 0;\n        padding: 0; }\n        .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-up {\n          height: 11.5px;\n          width: 100%;\n          display: flex; }\n          .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-up > .line {\n            height: 100%;\n            width: 100%;\n            border-top: 2px solid #535353; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-up > .line.left-div {\n              border-right: 1px solid #535353; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-up > .line.right-div {\n              border-left: 1px solid #535353; }\n        .react-workflow-editor-container.editor .workflow-node.case:first-child > .workflow-node-line-up > .line.left-div {\n          border-top-width: 0; }\n        .react-workflow-editor-container.editor .workflow-node.case:last-child > .workflow-node-line-up > .line.right-div {\n          border-top-width: 0; }\n        .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-down {\n          height: 11.5px;\n          width: 100%;\n          display: flex; }\n          .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-down > .line {\n            height: 100%;\n            width: 100%;\n            border-bottom: 2px solid #535353; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-down > .line.left-div {\n              border-right: 1px solid #535353; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-line-down > .line.right-div {\n              border-left: 1px solid #535353; }\n        .react-workflow-editor-container.editor .workflow-node.case:first-child > .workflow-node-line-down > .line.left-div {\n          border-bottom-width: 0; }\n        .react-workflow-editor-container.editor .workflow-node.case:last-child > .workflow-node-line-down > .line.right-div {\n          border-bottom-width: 0; }\n        .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap {\n          display: flex;\n          flex-grow: 1; }\n          .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap > .insert-rect-space {\n            display: block;\n            width: 2px;\n            background-color: red; }\n          .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap > .workflow-node-rect {\n            flex-grow: 1;\n            min-width: 150px;\n            border: 1px solid #464646;\n            margin: 0 4px;\n            border-radius: 5px;\n            display: flex;\n            align-items: center;\n            flex-direction: column; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap > .workflow-node-rect.draged {\n              background-color: #d2d2d2; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap > .workflow-node-rect.clicked {\n              outline-offset: 4px;\n              outline: 1px dashed red; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap > .workflow-node-rect > .title {\n              height: 36px;\n              background-size: 18px;\n              background-position: 50% 26px;\n              background-repeat: no-repeat; }\n            .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap > .workflow-node-rect .workflow-body {\n              padding: 0 4px;\n              flex-grow: 1; }\n              .react-workflow-editor-container.editor .workflow-node.case > .workflow-node-rect-wrap > .workflow-node-rect .workflow-body:empty {\n                height: 0;\n                flex-grow: 0; }\n      .react-workflow-editor-container.editor .workflow-node.switch {\n        margin-left: 4px;\n        margin-right: 4px;\n        border: 1px solid #464646;\n        border-radius: 5px;\n        padding-left: 8px;\n        padding-right: 8px; }\n        .react-workflow-editor-container.editor .workflow-node.switch.draged {\n          background-color: #d2d2d2; }\n        .react-workflow-editor-container.editor .workflow-node.switch.clicked {\n          outline-offset: 4px;\n          outline: 1px dashed red; }\n        .react-workflow-editor-container.editor .workflow-node.switch > .title {\n          height: 26px;\n          background-size: 18px;\n          background-position: 50% 26px;\n          background-repeat: no-repeat;\n          line-height: 26px; }\n          .react-workflow-editor-container.editor .workflow-node.switch > .title .expand-icon {\n            display: none;\n            margin-right: 6px;\n            width: 14px;\n            height: 14px; }\n          .react-workflow-editor-container.editor .workflow-node.switch > .title .collapse-icon {\n            display: inline;\n            margin-right: 6px;\n            width: 14px;\n            height: 14px; }\n        .react-workflow-editor-container.editor .workflow-node.switch.collapse > * {\n          display: none; }\n        .react-workflow-editor-container.editor .workflow-node.switch.collapse > .title {\n          display: block; }\n          .react-workflow-editor-container.editor .workflow-node.switch.collapse > .title .expand-icon {\n            display: inline; }\n          .react-workflow-editor-container.editor .workflow-node.switch.collapse > .title .collapse-icon {\n            display: none; }\n      .react-workflow-editor-container.editor .workflow-node.loop {\n        border-radius: 5px;\n        padding-left: 8px;\n        padding-right: 8px;\n        padding-bottom: 0;\n        border: 1px solid #464646;\n        border-radius: 5px; }\n        .react-workflow-editor-container.editor .workflow-node.loop.draged {\n          background-color: #d2d2d2; }\n        .react-workflow-editor-container.editor .workflow-node.loop.clicked {\n          outline-offset: 4px;\n          outline: 1px dashed red; }\n        .react-workflow-editor-container.editor .workflow-node.loop > .title {\n          height: 26px;\n          background-size: 18px;\n          background-position: 50% 26px;\n          background-repeat: no-repeat;\n          line-height: 26px; }\n          .react-workflow-editor-container.editor .workflow-node.loop > .title .expand-icon {\n            display: none;\n            margin-right: 6px;\n            width: 14px;\n            height: 14px; }\n          .react-workflow-editor-container.editor .workflow-node.loop > .title .collapse-icon {\n            display: inline;\n            margin-right: 6px;\n            width: 14px;\n            height: 14px; }\n        .react-workflow-editor-container.editor .workflow-node.loop.collapse > * {\n          display: none; }\n        .react-workflow-editor-container.editor .workflow-node.loop.collapse > .title {\n          display: block; }\n          .react-workflow-editor-container.editor .workflow-node.loop.collapse > .title .expand-icon {\n            display: inline; }\n          .react-workflow-editor-container.editor .workflow-node.loop.collapse > .title .collapse-icon {\n            display: none; }\n    .react-workflow-editor-container.editor .flow-line {\n      width: 150px;\n      display: flex;\n      flex-direction: column;\n      align-items: center; }\n      .react-workflow-editor-container.editor .flow-line .line {\n        width: 0px;\n        border: 1px solid #535353;\n        height: 11.5px;\n        flex-grow: 1; }\n        .react-workflow-editor-container.editor .flow-line .line.half-height {\n          height: 11.5px; }\n      .react-workflow-editor-container.editor .flow-line .rect {\n        display: none;\n        height: 6px;\n        width: 6px;\n        border: 1px dotted red;\n        border-radius: 50%; }\n      .react-workflow-editor-container.editor .flow-line.dragover > .line {\n        border-color: red;\n        height: 8.5px; }\n      .react-workflow-editor-container.editor .flow-line.dragover > .rect {\n        display: block; }\n      .react-workflow-editor-container.editor .flow-line.arrow-line .line {\n        height: 8px; }\n      .react-workflow-editor-container.editor .flow-line.arrow-line .arrow {\n        width: 0;\n        height: 0;\n        border-left: 4px solid transparent;\n        border-right: 4px solid transparent;\n        border-top: 7px solid #535353; }\n      .react-workflow-editor-container.editor .flow-line.arrow-line:last-child {\n        flex-grow: 1; }\n      .react-workflow-editor-container.editor .flow-line.arrow-line.dragover .line {\n        height: 5px; }\n      .react-workflow-editor-container.editor .flow-line.arrow-line.dragover > .arrow {\n        border-top-color: red; }\n    .react-workflow-editor-container.editor .workflow-body {\n      display: flex;\n      flex-direction: column;\n      align-items: center; }\n    .react-workflow-editor-container.editor .node-start,\n    .react-workflow-editor-container.editor .node-end {\n      height: 32px;\n      width: 100px;\n      display: flex;\n      align-items: center;\n      flex-direction: column-reverse; }\n      .react-workflow-editor-container.editor .node-start .i,\n      .react-workflow-editor-container.editor .node-end .i {\n        width: 32px;\n        height: 32px;\n        background-size: contain; }\n    .react-workflow-editor-container.editor .switch-body {\n      display: flex;\n      flex-direction: row; }\n";
styleInject(css$1);

var COLLAPSE_STATE_ID_PREFIX = 'collapse-state-id-';

var getDataFromProps = function getDataFromProps(_data) {
  if (!_data) {
    return {
      id: 'root',
      children: []
    };
  }

  if (!_data.children) {
    return _objectSpread2({}, _data, {
      children: []
    });
  }

  return _data;
};

var Editor = function Editor(props, ref) {
  var workflowRef = React.useRef();

  var _useState = React.useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      data = _useState2[0],
      setData = _useState2[1];

  var _useState3 = React.useState(null),
      _useState4 = _slicedToArray(_useState3, 2),
      prevData = _useState4[0],
      setPrevData = _useState4[1];

  var _useState5 = React.useState(null),
      _useState6 = _slicedToArray(_useState5, 2),
      dataFromProps = _useState6[0],
      setDataFromProps = _useState6[1];

  var _useState7 = React.useState(false),
      _useState8 = _slicedToArray(_useState7, 2),
      hasGetDerivedStateFromPropsFunc = _useState8[0],
      setHasGetDerivedStateFromPropsFunc = _useState8[1];

  var _useState9 = React.useState(null),
      _useState10 = _slicedToArray(_useState9, 2),
      currentId = _useState10[0],
      setCurrentId = _useState10[1];

  var _useState11 = React.useState({}),
      _useState12 = _slicedToArray(_useState11, 2),
      collapseStateIds = _useState12[0],
      setCollapseStateIds = _useState12[1];

  var _useState13 = React.useState(null),
      _useState14 = _slicedToArray(_useState13, 2),
      dragId = _useState14[0],
      setDragId = _useState14[1];

  var _useState15 = React.useState(false),
      _useState16 = _slicedToArray(_useState15, 2),
      isDragCase = _useState16[0],
      setIsDragCase = _useState16[1];

  var _useState17 = React.useState(null),
      _useState18 = _slicedToArray(_useState17, 2),
      containerId = _useState18[0],
      setContainerId = _useState18[1];

  var _useState19 = React.useState(null),
      _useState20 = _slicedToArray(_useState19, 2),
      containerIndex = _useState20[0],
      setContainerIndex = _useState20[1];

  var _useState21 = React.useState(function () {
    var initialHisory = new stateshot_1();
    initialHisory.pushSync(getDataFromProps());
    return initialHisory;
  }),
      _useState22 = _slicedToArray(_useState21, 1),
      history = _useState22[0];

  var newData = getDataFromProps(props.data);
  var dataString = JSON.stringify(newData);

  if (!prevData || dataFromProps !== prevData) {
    setPrevData(dataFromProps);
    setDataFromProps(dataString);
    setData(newData);
    setHasGetDerivedStateFromPropsFunc(true);
  }

  var handleUpdateData = function handleUpdateData(updatedData) {
    setData(_objectSpread2({}, updatedData));
    history.pushSync(updatedData);
  };

  var handleClearState = function handleClearState() {
    setContainerId(null);
    setContainerIndex(null);
    setDragId(null);
    setIsDragCase(false);
  };

  var handleKeyUp = function handleKeyUp(event) {
    if (event.key === 'Delete') {
      if (!currentId) {
        return;
      }

      var sourceParentNode = getParentNodeById(data, currentId);
      var sourceIndex = sourceParentNode.children.findIndex(function (x) {
        return x.id === currentId;
      });

      var _getNewFlowByDel = getNewFlowByDel({
        config: data,
        sourceId: currentId
      }),
          flow = _getNewFlowByDel.flow,
          nodes = _getNewFlowByDel.nodes;

      if (props.onChange && typeof props.onChange === 'function') {
        props.onChange({
          data: flow,
          detail: {
            action: 'del',
            position: {
              id: sourceParentNode.id,
              index: sourceIndex
            },
            nodes: nodes
          }
        });
      }

      handleClearState();
      setCurrentId(null);
      handleUpdateData(flow);
      return;
    }

    if (event.ctrlKey) {
      switch (event.key) {
        case 'z':
          (function () {
            var undoneData = history.undo().get();
            setData(undoneData);

            if (props.onChange && typeof props.onChange === 'function') {
              props.onChange({
                data: data,
                detail: {
                  action: 'undo'
                }
              });
            }
          })();

          break;

        case 'y':
          (function () {
            var redoData = history.redo().get();
            setData(redoData);

            if (props.onChange && typeof props.onChange === 'function') {
              props.onChange({
                data: data,
                detail: {
                  action: 'undo'
                }
              });
            }
          })();

          break;

        default:
          break;
      }
    }
  };

  var handleCopy = function handleCopy(event) {
    var node = getNodeById(data, currentId);
    var text = JSON.stringify(node);

    if (text) {
      event.clipboardData.setData('text/plain', "react-workflow-editor:".concat(text));
    }

    event.preventDefault();
  };

  var handlePaste = function handlePaste(event) {
    var clipboardData = event.clipboardData;

    if (!(clipboardData && clipboardData.items)) {
      return;
    }

    var text = clipboardData.getData('text/plain');

    if (text.startsWith('react-workflow-editor:')) {
      var nodeStr = text.substring('react-workflow-editor:'.length);

      var node = function () {
        try {
          var value = JSON.parse(nodeStr);
          return value;
        } catch (e) {
          return null;
        }
      }();

      if (!node) {
        return;
      }

      var _ref = function () {
        var unPasteResult = {
          containerId: null,
          containerIndex: null
        };

        if (!currentId && node.type !== 'case') {
          return {
            containerId: 'root',
            containerIndex: data.children.length
          };
        }

        var currentNode = getNodeById(data, currentId);

        if (currentNode.type === 'loop' && node.type !== 'case' || currentNode.type === 'case' && node.type !== 'case' || currentNode.type === 'switch' && node.type === 'case') {
          return {
            containerId: currentId,
            containerIndex: currentNode.children.length
          };
        }

        if (node.type === 'case' && currentNode.type !== 'case') {
          return unPasteResult;
        }

        var containerNode = getParentNodeById(data, currentId);
        var containerIndex2 = 1 + containerNode.children.findIndex(function (x) {
          return x.id === currentId;
        });
        return {
          containerId: containerNode.id,
          containerIndex: containerIndex2
        };
      }(),
          containerId1 = _ref.containerId,
          containerIndex1 = _ref.containerIndex;

      if (!containerId1) {
        return;
      }

      var _getNewFlowByPaste = getNewFlowByPaste({
        config: data,
        sourceNode: node,
        containerId: containerId1,
        containerIndex: containerIndex1
      }),
          updatedData = _getNewFlowByPaste.data,
          copyDetail = _getNewFlowByPaste.copyDetail;

      var sourceParentNode = getParentNodeById(updatedData, node.id);
      var sourceIndex = sourceParentNode.children.findIndex(function (x) {
        return x.id === node.id;
      });

      if (props.onChange && typeof props.onChange === 'function') {
        props.onChange({
          data: updatedData,
          detail: {
            action: 'paste',
            position: {
              id: sourceParentNode.id,
              index: sourceIndex
            },
            position2: {
              id: containerId,
              index: containerIndex
            },
            nodes: copyDetail.map(function (x) {
              return x.from;
            }),
            nodes2: copyDetail.map(function (x) {
              return x.to;
            })
          }
        });
      }

      handleClearState();
      handleUpdateData(updatedData);
    }
  };

  React.useEffect(function () {
    document.addEventListener('copy', handleCopy);
    document.addEventListener('paste', handlePaste);
    document.addEventListener('keyup', handleKeyUp);
    return function () {
      document.removeEventListener('copy', handleCopy);
      document.removeEventListener('paste', handlePaste);
      document.removeEventListener('keyup', handleKeyUp);
    };
  });

  var handleClick = function handleClick(id) {
    return function (e) {
      e.stopPropagation();
      setCurrentId(id);

      if (props.onClick && typeof props.onClick === 'function') {
        props.onClick(id);
      }
    };
  };

  var handleClickExpandIcon = function handleClickExpandIcon(id) {
    return function (e) {
      e.stopPropagation();
      var stateId = "".concat(COLLAPSE_STATE_ID_PREFIX).concat(id);
      setCollapseStateIds(_objectSpread2({}, collapseStateIds, _defineProperty({}, stateId, !collapseStateIds[stateId])));
    };
  };

  var handleDragStart = function handleDragStart(id) {
    return function (e) {
      e.dataTransfer.setData('dragId', id);
      e.dataTransfer.setDragImage(e.target, 10, 10);
      e.stopPropagation();
      var dragNode = getNodeById(data, id);
      setDragId(id);
      setIsDragCase(dragNode.type === 'case');
    };
  };

  var handleDragOver = function handleDragOver(_ref2) {
    var currentContainerId = _ref2.containerId,
        currentContainerIndex = _ref2.containerIndex;
    return function (e) {
      e.preventDefault();
      e.stopPropagation();

      if (currentContainerId !== containerId || currentContainerIndex !== containerIndex) {
        setContainerId(currentContainerId);
        setContainerIndex(currentContainerIndex);
      }
    };
  };

  var handleDragLeave = function handleDragLeave(_ref3) {
    var currentContainerId = _ref3.containerId,
        currentContainerIndex = _ref3.containerIndex;
    return function (e) {
      e.stopPropagation();

      if (currentContainerId === containerId && currentContainerIndex === containerIndex) {
        setContainerId(null);
        setContainerIndex(null);
      }
    };
  };

  var handleDrop = function handleDrop(e) {
    e.stopPropagation();
    var sourceId = e.dataTransfer.getData('dragId');
    var nodeName = e.dataTransfer.getData('nodeName');
    var method = e.dataTransfer.getData('method');

    if (method === 'new' && containerId === 'recycle') {
      handleClearState();
      return;
    }

    if (method === 'new') {
      var node = JSON.parse(e.dataTransfer.getData('node'));
      var type = e.dataTransfer.getData('type');
      node = getNewNode(type, node.props.action, node.props.name, getNewIdFunc(data));

      var _getNewFlowByAdd = getNewFlowByAdd({
        config: data,
        node: node,
        containerId: containerId,
        containerIndex: containerIndex
      }),
          flow = _getNewFlowByAdd.flow,
          nodes = _getNewFlowByAdd.nodes;

      if (props.onChange && typeof props.onChange === 'function') {
        props.onChange({
          data: flow,
          detail: {
            action: 'add',
            position: {
              id: containerId,
              index: containerIndex
            },
            nodes: nodes
          }
        });
      }

      handleClearState();
      handleUpdateData(flow);
      return;
    }

    var sourceParentNode = getParentNodeById(data, sourceId);
    var sourceIndex = sourceParentNode.children.findIndex(function (x) {
      return x.id === sourceId;
    });

    if (containerId === 'recycle') {
      var _getNewFlowByDel2 = getNewFlowByDel({
        config: data,
        sourceId: sourceId
      }),
          _flow = _getNewFlowByDel2.flow,
          _nodes = _getNewFlowByDel2.nodes;

      if (props.onChange && typeof props.onChange === 'function') {
        props.onChange({
          data: _flow,
          detail: {
            action: 'del',
            position: {
              id: sourceParentNode.id,
              index: sourceIndex
            },
            nodes: _nodes
          }
        });
      }

      handleClearState();
      setContainerId(null);
      handleUpdateData(_flow);
      return;
    }

    var action = e.nativeEvent.ctrlKey || e.nativeEvent.metaKey ? 'copy' : 'move';

    if (action === 'move') {
      if (sourceParentNode.id === containerId && (containerIndex === sourceIndex || containerIndex === sourceIndex + 1)) {
        handleClearState();
        return;
      }
    }

    if (action === 'copy') {
      var _getNewFlowByCopy = getNewFlowByCopy({
        config: data,
        sourceId: sourceId,
        containerId: containerId,
        containerIndex: containerIndex
      }),
          data1 = _getNewFlowByCopy.data,
          copyDetail = _getNewFlowByCopy.copyDetail;

      if (props.onChange && typeof props.onChange === 'function') {
        props.onChange({
          data: data1,
          detail: {
            action: 'copy',
            position: {
              id: sourceParentNode.id,
              index: sourceIndex
            },
            position2: {
              id: containerId,
              index: containerIndex
            },
            nodes: copyDetail.map(function (x) {
              return x.from;
            }),
            nodes2: copyDetail.map(function (x) {
              return x.to;
            })
          }
        });
      }

      handleClearState();
      handleUpdateData(data1);
      return;
    }

    if (action === 'move') {
      var _getNewFlowByMove = getNewFlowByMove({
        config: data,
        sourceId: sourceId,
        containerId: containerId,
        containerIndex: containerIndex
      }),
          _flow2 = _getNewFlowByMove.flow,
          _nodes2 = _getNewFlowByMove.nodes;

      if (_flow2 === data) {
        handleClearState();
        return;
      }

      if (props.onChange && typeof props.onChange === 'function') {
        props.onChange({
          data: _flow2,
          detail: {
            action: 'move',
            position: {
              id: sourceParentNode.id,
              index: sourceIndex
            },
            position2: {
              id: containerId,
              index: containerIndex
            },
            nodes: _nodes2
          }
        });
      }

      handleClearState();
      handleUpdateData(_flow2);
    }
  };

  var renderLine = function renderLine(_ref4) {
    var currentContainerId = _ref4.containerId,
        currentContainerIndex = _ref4.containerIndex,
        hasArrow = _ref4.hasArrow,
        style = _ref4.style;
    var arrowClassName = hasArrow ? 'arrow-line' : '';
    var dragoverClassName = currentContainerId === containerId && currentContainerIndex === containerIndex ? 'dragover' : '';
    return React__default.createElement("div", {
      className: "flow-line ".concat(arrowClassName, " ").concat(dragoverClassName),
      key: "line-".concat(containerId, ":{containerIndex}"),
      style: style,
      onDragOver: handleDragOver({
        containerId: currentContainerId,
        containerIndex: currentContainerIndex
      }),
      onDragLeave: handleDragLeave({
        containerId: currentContainerId,
        containerIndex: currentContainerIndex
      }),
      onDrop: handleDrop
    }, React__default.createElement("div", {
      className: "line"
    }), React__default.createElement("div", {
      className: "rect"
    }), React__default.createElement("div", {
      className: "line"
    }), hasArrow && React__default.createElement("div", {
      className: "arrow"
    }));
  };

  var renderHalfHeightLine = function renderHalfHeightLine() {
    return React__default.createElement("div", {
      className: "flow-line"
    }, React__default.createElement("div", {
      className: "line"
    }));
  };

  var renderNode = function renderNode(node) {
    var collapseState = collapseStateIds["".concat(COLLAPSE_STATE_ID_PREFIX).concat(node.id)];

    if (node.type === 'loop') {
      return React__default.createElement("div", {
        key: node.id,
        onClick: handleClick(node.id),
        className: "".concat(collapseState ? 'collapse' : '', " workflow-node loop ").concat(dragId === node.id ? 'draged' : '', " ").concat(currentId === node.id ? 'clicked' : ''),
        draggable: "true",
        onDragStart: handleDragStart(node.id)
      }, React__default.createElement("div", {
        className: "title",
        onClick: handleClickExpandIcon(node.id)
      }, React__default.createElement("div", null, React__default.createElement(FontAwesomeIcon, {
        icon: "plus-square",
        className: "expand-icon"
      }), React__default.createElement(FontAwesomeIcon, {
        icon: "minus-square",
        className: "collapse-icon"
      }), React__default.createElement("span", {
        style: {
          verticalAlign: 'top'
        }
      }, node.name || node.type), React__default.createElement(FontAwesomeIcon, {
        icon: "undo",
        style: {
          width: '18px',
          height: '18px',
          marginLeft: '4px',
          marginTop: '2px'
        }
      }))), renderLine({
        containerId: node.id,
        containerIndex: 0
      }), React__default.createElement("div", {
        className: "workflow-body"
      }, node.children.map(function (x, index) {
        return [renderNode(x), renderLine({
          containerId: node.id,
          containerIndex: index + 1,
          hasArrow: true
        })];
      })));
    }

    if (node.type === 'switch') {
      return React__default.createElement("div", {
        key: node.id,
        className: "".concat(collapseState ? 'collapse' : '', " workflow-node switch ").concat(dragId === node.id ? 'draged' : '', " ").concat(currentId === node.id ? 'clicked' : ''),
        draggable: "true",
        onClick: handleClick(node.id),
        onDragStart: handleDragStart(node.id)
      }, React__default.createElement("div", {
        className: "title",
        onClick: handleClickExpandIcon(node.id)
      }, React__default.createElement("div", null, React__default.createElement(FontAwesomeIcon, {
        icon: "plus-square",
        className: "expand-icon"
      }), React__default.createElement(FontAwesomeIcon, {
        icon: "minus-square",
        className: "collapse-icon"
      }), React__default.createElement("span", {
        style: {
          verticalAlign: 'top'
        }
      }, node.name || node.type), React__default.createElement(FontAwesomeIcon, {
        icon: "sitemap",
        alt: "switch",
        style: {
          width: '18px',
          height: '18px',
          marginLeft: '4px',
          marginTop: '3px'
        }
      }))), renderHalfHeightLine(), React__default.createElement("div", {
        className: "switch-body"
      }, node.children.map(function (x, index) {
        return [React__default.createElement("div", {
          className: "workflow-node case",
          key: "workflow-node-".concat(x.id)
        }, React__default.createElement("div", {
          className: "workflow-node-line-up"
        }, React__default.createElement("div", {
          className: "line left-div"
        }), React__default.createElement("div", {
          className: "line right-div"
        })), React__default.createElement("div", {
          className: "workflow-node-rect-wrap"
        }, React__default.createElement("div", {
          className: "workflow-node-rect ".concat(dragId === x.id ? 'draged' : '', " ").concat(currentId === x.id ? 'clicked' : ''),
          draggable: "true",
          onClick: handleClick(x.id),
          onDragStart: handleDragStart(x.id),
          onDragOver: handleDragOver({
            containerId: node.id,
            containerIndex: index + 1,
            id: x.id
          }),
          onDragLeave: handleDragLeave({
            containerId: node.id,
            containerIndex: index + 1
          }),
          onDrop: handleDrop
        }, React__default.createElement("div", {
          className: "title"
        }, React__default.createElement("div", null, x.name), React__default.createElement(FontAwesomeIcon, {
          icon: "bars",
          style: {
            width: '18px',
            height: '18px'
          }
        })), renderLine({
          containerId: x.id,
          containerIndex: 0,
          style: {
            flexGrow: x.children && x.children.length ? 0 : 1
          }
        }), React__default.createElement("div", {
          className: "workflow-body"
        }, x.children && x.children.map(function (y, yIndex) {
          return [renderNode(y), renderLine({
            containerId: x.id,
            containerIndex: yIndex + 1,
            hasArrow: true
          })];
        }))), containerId === node.id && containerIndex === index + 1 && isDragCase && dragId !== x.id && React__default.createElement("div", {
          className: "insert-rect-space"
        })), React__default.createElement("div", {
          className: "workflow-node-line-down"
        }, React__default.createElement("div", {
          className: "line left-div"
        }), React__default.createElement("div", {
          className: "line right-div"
        })))];
      })), renderHalfHeightLine());
    }

    var color = '#ccc';
    return React__default.createElement("div", {
      key: node.id,
      className: "workflow-node normal ".concat(dragId === node.id ? 'draged' : '', " ").concat(currentId === node.id ? 'clicked' : ''),
      style: {
        backgroundColor: color,
        boxShadow: "0 0 0 2px white, 0 0 0 3px ".concat(color)
      },
      onClick: handleClick(node.id),
      draggable: "true",
      onDragStart: handleDragStart(node.id)
    }, node.name || 'Node');
  };

  if (!hasGetDerivedStateFromPropsFunc) {
    console.error('Component react-workflow-editor need react with version 16.4 or above.');
    return null;
  }

  if (!data) {
    return null;
  }

  return React__default.createElement("div", {
    className: "react-workflow-editor-wrap react-workflow-editor-container editor",
    style: props.style || {},
    ref: workflowRef // eslint-disable-next-line jsx-a11y/no-noninteractive-tabindex
    ,
    tabIndex: 0,
    onClick: handleClearState
  }, window.recycleWrap && reactDom.createPortal(React__default.createElement(Overlay, {
    visible: !!dragId,
    onDragOver: handleDragOver({
      containerId: 'recycle',
      containerIndex: null
    }),
    onDragLeave: handleDragLeave({
      containerId: 'recycle',
      containerIndex: null
    }),
    onDrop: handleDrop
  }), window.recycleWrap), React__default.createElement("div", {
    className: "main-workflow-theme"
  }, React__default.createElement("div", {
    className: "workflow-body root"
  }, React__default.createElement("div", {
    className: "node-start"
  }, React__default.createElement(FontAwesomeIcon, {
    icon: "play-circle",
    style: {
      width: '32px',
      height: '32px'
    }
  })), renderLine({
    containerId: 'root',
    containerIndex: 0
  }), data.children.map(function (x, index) {
    var hasArrow = index !== data.children.length - 1;
    return [renderNode(x), renderLine({
      containerId: 'root',
      containerIndex: index + 1,
      hasArrow: hasArrow
    })];
  }), React__default.createElement("div", {
    className: "node-end"
  }, React__default.createElement(FontAwesomeIcon, {
    icon: "stop-circle",
    style: {
      width: '32px',
      height: '32px'
    }
  })))));
};

Editor.propTypes = {
  data: PropTypes.shape({
    id: PropTypes.string,
    children: PropTypes.array
  }),
  template: PropTypes.object,
  theme: PropTypes.string,
  style: PropTypes.object,
  onClick: PropTypes.func,
  onChange: PropTypes.func
};

var css$2 = ".react-workflow-toobar-container {\n  margin-left: 1px;\n  display: flex;\n  flex-direction: row;\n  flex-wrap: wrap;\n  writing-mode: vertical-lr;\n  align-content: flex-start;\n  background-color: #ddd;\n  border-right: 1px solid #444;\n  padding: 2px; }\n  .react-workflow-toobar-container .icon-wrap {\n    width: 30px;\n    height: 30px;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    writing-mode: horizontal-tb;\n    margin: 2px; }\n    .react-workflow-toobar-container .icon-wrap:hover {\n      outline: 1px solid blue;\n      background-color: lightseagreen; }\n  .react-workflow-toobar-container .icon {\n    pointer-events: none;\n    width: 24px;\n    height: 24px;\n    background-size: contain; }\n    .react-workflow-toobar-container .icon > svg {\n      display: block;\n      width: 20px;\n      height: 20px; }\n";
styleInject(css$2);

var DRAG_IMAGE_DOM_ID = 'flow-icon-draged-image';

var handleDragStart = function handleDragStart(node) {
  return function (e) {
    e.dataTransfer.setData('type', node.type);
    e.dataTransfer.setData('node', JSON.stringify(node));
    e.dataTransfer.setData('nodeName', node.props.name);
    e.dataTransfer.setData('method', 'new');
    var dragImage = e.target.cloneNode();
    dragImage.innerHTML = node.props.name;
    dragImage.style.width = '150px';
    dragImage.style.height = '23px';
    dragImage.style.display = 'block';
    dragImage.style.border = '1px solid black';
    dragImage.style.backgroundColor = 'lightyellow';
    dragImage.style.textAlign = 'center';
    dragImage.id = DRAG_IMAGE_DOM_ID;
    document.body.append(dragImage);
    dragImage.style.position = 'absolute';
    dragImage.style.left = '-100px';
    dragImage.style.top = '-100px';
    e.dataTransfer.setDragImage(dragImage, 10, 10);
  };
};

var handleDragEnd = function handleDragEnd() {
  var dragImage = document.getElementById(DRAG_IMAGE_DOM_ID);

  if (dragImage) {
    document.body.removeChild(dragImage);
  }
};

var toolbar = function toolbar(_ref) {
  var template = _ref.template,
      width = _ref.width,
      iconWritingMode = _ref.iconWritingMode;
  var nodes = template.nodes,
      nodeEntity = template.entities.node;
  var tools = nodes.filter(function (x) {
    return nodeEntity[x].props.showInToolbar === 'Y';
  });
  return React__default.createElement("div", {
    className: "flow-icon-toolbar react-workflow-toobar-container",
    style: {
      width: "".concat(width, "px"),
      writingMode: iconWritingMode
    }
  }, tools.map(function (x) {
    return React__default.createElement("div", {
      className: "icon-wrap",
      key: x,
      title: nodeEntity[x].name,
      draggable: "true",
      onDragStart: handleDragStart(nodeEntity[x]),
      onDragEnd: handleDragEnd
    }, React__default.createElement("div", {
      className: "icon"
    }, typeof nodeEntity[x].icon === 'string' ? React__default.createElement(FontAwesomeIcon, {
      icon: nodeEntity[x].icon,
      className: nodeEntity[x].className
    }) : nodeEntity[x].icon));
  }));
};

toolbar.propsType = {
  template: PropTypes.object
};

var css$3 = ".react-workflow-editor-container-wrapper {\n  height: 100%;\n  width: 100%;\n  display: flex;\n  flex-direction: row;\n  position: relative;\n  overflow: hidden; }\n";
styleInject(css$3);

var iconSize = 34;
var toolbarPadding = 2;

var EditorContainer = function EditorContainer(_ref) {
  var iconWritingMode = _ref.iconWritingMode,
      template = _ref.template,
      data = _ref.data,
      style = _ref.style,
      workspaceStyle = _ref.workspaceStyle,
      onClick = _ref.onClick,
      onChange = _ref.onChange,
      workflowId = _ref.workflowId;

  var _useState = React.useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      height = _useState2[0],
      setHeight = _useState2[1];

  var _useState3 = React.useState(iconSize + toolbarPadding),
      _useState4 = _slicedToArray(_useState3, 2),
      width = _useState4[0],
      setWidth = _useState4[1];

  var containerRef = React.useRef();
  React.useEffect(function () {
    if (containerRef && containerRef.current.offsetHeight !== height) {
      var nodes = template.nodes,
          nodeEntity = template.entities.node;
      var tools = nodes.filter(function (x) {
        return nodeEntity[x].props.showInToolbar === 'Y';
      });
      var count = tools.length;
      var rows = Math.floor((containerRef.current.offsetHeight - toolbarPadding * 2) / iconSize);
      var columns = Math.ceil(count / rows);
      var newWidth = columns * iconSize;
      setWidth(newWidth);
      setHeight(containerRef.current.offsetHeight);
    }
  });
  return React__default.createElement("div", {
    className: "react-workflow-editor-container-wrapper",
    id: workflowId || 'react-workflow-editor-container-wrapper',
    style: style,
    ref: containerRef
  }, React__default.createElement(toolbar, {
    template: template,
    width: width,
    iconWritingMode: iconWritingMode
  }), React__default.createElement(Editor, {
    data: data,
    style: workspaceStyle,
    onChange: onChange,
    onClick: onClick,
    template: template
  }), React__default.createElement("div", {
    ref: function ref(_ref2) {
      window.recycleWrap = _ref2;
      return window.recycleWrap;
    },
    style: {
      position: 'absolute',
      right: '20px',
      top: '10px'
    }
  }));
};

var icons = require('@fortawesome/free-solid-svg-icons');

library.add.apply(library, _toConsumableArray(Object.values(icons.fas)));

module.exports = EditorContainer;
//# sourceMappingURL=index.js.map
